ClassToolHandler = class(Turbine.UI.Control)
function ClassToolHandler:Constructor()
    Turbine.UI.Control.Constructor(self)
    if not(Settings.ClassToolsEnabled) then return end

    self.tool = nil

    self.playerClass = Turbine.Gameplay.LocalPlayer.GetInstance():GetClass()

    self.classSettings = LoadTable(Turbine.DataScope.Account, "PrimeClassTools")

    if self.classSettings == nil then self.classSettings = {} end

    if self.playerClass == Turbine.Gameplay.Class.Beorning then

        self.tool = BeorningTools(self.classSettings[self.playerClass])

    elseif self.playerClass == Turbine.Gameplay.Class.Burglar then 

    elseif self.playerClass == Turbine.Gameplay.Class.Champion then

    elseif self.playerClass == Turbine.Gameplay.Class.Captain then

    elseif self.playerClass == Turbine.Gameplay.Class.Guardian then

        if Roles:GetLine() == 1 then self.tool = GuardianTools(self.classSettings[self.playerClass]) end

    elseif self.playerClass == Turbine.Gameplay.Class.Hunter then

        self.tool = HunterTools(self.classSettings[self.playerClass])
        
    elseif self.playerClass == Turbine.Gameplay.Class.LoreMaster then

    elseif self.playerClass == Turbine.Gameplay.Class.Minstrel then

    elseif self.playerClass == Turbine.Gameplay.Class.RuneKeeper then

    elseif self.playerClass == Turbine.Gameplay.Class.Warden then
        
        self.tool = WardenTools(self.classSettings[self.playerClass])

    end

    self.Update = function()
        if Turbine.Engine.GetGameTime() > self.reloadTime then
            self:ReloadTool()
            self:SetWantsUpdates(false)
        end
    end
end

function ClassToolHandler:CheckForTools()
    if self.tool then return self.tool else return false end
end

function ClassToolHandler:Unload()

    if self.tool then
        self.tool:RemoveCallbacks()
        Settings.ClassToolsX, Settings.ClassToolsY = self.tool:GetPosition()
        self.classSettings[self.playerClass] = self.tool:GetData()
        SaveTable(Turbine.DataScope.Account, "PrimeClassTools", self.classSettings)
    end
    
end

function ClassToolHandler:CheckClass()
    if self.playerClass == Turbine.Gameplay.Class.Beorning then

        return true

    elseif self.playerClass == Turbine.Gameplay.Class.Burglar then 

    elseif self.playerClass == Turbine.Gameplay.Class.Champion then

    elseif self.playerClass == Turbine.Gameplay.Class.Captain then

    elseif self.playerClass == Turbine.Gameplay.Class.Guardian then

        if Roles:GetLine() == 1 then return true else return false end

    elseif self.playerClass == Turbine.Gameplay.Class.Hunter then

        return true
        
    elseif self.playerClass == Turbine.Gameplay.Class.LoreMaster then

    elseif self.playerClass == Turbine.Gameplay.Class.Minstrel then

    elseif self.playerClass == Turbine.Gameplay.Class.RuneKeeper then

    elseif self.playerClass == Turbine.Gameplay.Class.Warden then
        
        return true

    end
end

function ClassToolHandler:ReloadTool()
    if self.tool then
        if self:CheckClass() then
            self.tool:Reload()
        else
            self.tool:Unload()
        end
    end
end

function ClassToolHandler:ReloadToolWithDelay()
    self.reloadTime = Turbine.Engine.GetGameTime() + 5
    self:SetWantsUpdates(true)
end

function ClassToolHandler:ToggleMove()
    if self.tool then self.tool:ToggleMove() end
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

ClassToolsOptions = class(Turbine.UI.Control)
function ClassToolsOptions:Constructor(parent)
    local width = 750
    local height = 500
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetParent(parent)
    self:SetPosition(0,0);
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10 - 2, 10 - 2)
    SingleBackground:SetSize(730 + 4, 450 + 4)
    SingleBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(self)
    SingleBackground:SetPosition(10, 10)
    SingleBackground:SetSize(730, 450)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox = Turbine.UI.Lotro.CheckBox();
    EffectBox:SetParent(SingleBackground)
    EffectBox:SetPosition(10, 10);
    EffectBox:SetSize(200,20);
    EffectBox:SetChecked(Settings.ClassToolsEnabled)
    EffectBox:SetText("Class Tools Enabled");
    EffectBox:SetVisible(true);

    EffectBox.CheckedChanged = function()
        Settings.ClassToolsEnabled = EffectBox:IsChecked()
        MasterOptions:ChangesMade()
    end

    self.moveButton = Turbine.UI.Lotro.Button()
    self.moveButton:SetParent(SingleBackground)
    self.moveButton:SetText("Move")
    self.moveButton:SetPosition(210, 10)
    self.moveButton.Click = function()
        ClassTools:ToggleMove()
    end

    local container = Turbine.UI.ListBox()
    container:SetParent(SingleBackground)
    container:SetSize(700, 240)
    container:SetPosition(10, 30)
    --container:SetBackColor(GoldColor)
    container:SetVisible(true)
    container:SetWantsKeyEvents(true)
    container:SetMouseVisible(true)
    --container:SetBackColor(GetRandomColour())

    local containerScrollbar = Turbine.UI.Lotro.ScrollBar();
    containerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    containerScrollbar:SetParent( SingleBackground );
    containerScrollbar:SetPosition( 780 - 10, 10 );
    containerScrollbar:SetSize( 10, 400 );
    container:SetVerticalScrollBar( containerScrollbar );

    self.createSkillBar = function(name, load, x, y)

        local pluginBar = Turbine.UI.Control()
        pluginBar:SetSize(800, 40)
        pluginBar:SetBackColor(Turbine.UI.Color(0, 0, 0))

        local backgroundBar = Turbine.UI.Control()
        backgroundBar:SetSize(800, 38)
        backgroundBar:SetPosition(0, 1)
        backgroundBar:SetParent(pluginBar)
        backgroundBar:SetMouseVisible(false)
        backgroundBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
        --pluginBar:SetBackColor(GetRandomColour())

        local nameLabel = Turbine.UI.Label()
        nameLabel:SetParent(pluginBar)
        nameLabel:SetSize(200, 20)
        nameLabel:SetPosition(0, 10)
        nameLabel:SetMouseVisible(false)
        nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
        nameLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        nameLabel:SetMultiline(false)
        nameLabel:SetText(name)

        local EffectBox = Turbine.UI.Lotro.CheckBox();
        EffectBox:SetParent(pluginBar)
        EffectBox:SetPosition(160, 10);
        EffectBox:SetSize(120,20);
        EffectBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        EffectBox:SetChecked(load)
        EffectBox:SetText("Load");
        EffectBox:SetVisible(true);

        local ScaleLabel = Turbine.UI.Label()
        ScaleLabel:SetParent(pluginBar)
        ScaleLabel:SetSize(200, 30)
        ScaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
        ScaleLabel:SetPosition(230, 10)
        ScaleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        ScaleLabel:SetText("X-axis priority") 
    
        local BarScaleBar = Turbine.UI.Lotro.TextBox()
        BarScaleBar:SetParent(pluginBar)
        BarScaleBar:SetSize(50, 30)
        BarScaleBar:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        BarScaleBar:SetPosition(340, 5)
        BarScaleBar:SetText(x)

        local EffectBox1 = Turbine.UI.Lotro.CheckBox();
        EffectBox1:SetParent(pluginBar)
        EffectBox1:SetPosition(420, 10);
        EffectBox1:SetSize(120,20);
        EffectBox1:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        EffectBox1:SetChecked(y == 1)
        EffectBox1:SetText("Top bar");
        EffectBox1:SetVisible(true);

        local EffectBox2 = Turbine.UI.Lotro.CheckBox();
        EffectBox2:SetParent(pluginBar)
        EffectBox2:SetPosition(520, 10);
        EffectBox2:SetSize(120,20);
        EffectBox2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        EffectBox2:SetChecked(y == 2)
        EffectBox2:SetText("Bottom bar");
        EffectBox2:SetVisible(true);

        EffectBox1.CheckedChanged = function()
            if EffectBox1:IsChecked() then
                EffectBox2:SetChecked(false)
            end
        end
    
        EffectBox2.CheckedChanged = function()
            if EffectBox2:IsChecked() then
                EffectBox1:SetChecked(false)
            end
        end

        local Button2 = Turbine.UI.Lotro.Button()
        Button2:SetParent(pluginBar)
        Button2:SetSize(80, 20)
        Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        Button2:SetMouseVisible(true)
        Button2:SetPosition(620, 10)
        Button2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
        Button2:SetText("Save")

        Button2.Click = function()
            local ybar = 1
            if EffectBox2:IsChecked() then ybar = 2 end
            self.tool:ChangeData(name, {EffectBox:IsChecked(), tonumber(BarScaleBar:GetText()), ybar})
        end



        return pluginBar
    end

    self.tool = ClassTools:CheckForTools()
    if not(self.tool) then return end

    for key, value in spairs(self.tool:GetData(), 
    function(t,a,b) 
        if t[a][3] < t[b][3] then
            return true
        elseif t[a][3] > t[b][3] then
            return false
        elseif t[a][3] == t[b][3] then
            return t[a][2] < t[b][2] 
        end
    end) do container:AddItem(self.createSkillBar(key, value[1], value[2], value[3])) end

    if self.tool then self.specificOptions = self.tool:GetOptions(self, 110, 300) end

end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

GuardianTools = class(Turbine.UI.Window)
function GuardianTools:Constructor(data)
    Turbine.UI.Window.Constructor(self)
    self.width = 500
    self.height = 150
    self:SetPosition(Settings.ClassToolsX, Settings.ClassToolsY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.data = data

    self.moveBox = MoveBox(self, self.width, self.height, "Guardian Tools")

    self.ReactionBar = DynamicSkillBar(self, 0, 50, self.width, 32, 32, 2, true)
    self.SmallCDBar = DynamicSkillBar(self, 0, 18, self.width / 2 - 25, 32, 32, 3, true)
    self.BigCDBar = DynamicSkillBar(self, self.width / 2 + 25, 18, self.width / 2 - 25, 32, 32, 1, true)

    -- Add small health bar

    -- Add skill quickslots
    self.normalSkillBar = DynamicSkillBar(self, 0, 82, self.width, 64, 32, 4, false)

    -- Proper cleaning
    self.effectCallbacks = {}
    self.skillCallbacks = {}
    self.skillsLUT = {}
    self.playerCallbacks = {}

    self.skillLUT = {}

    self.normalSkills = {}

    self.baseSize = 32
    self.reactionSize = 32
    self.fortSize = 50

    self.specialSkillCount = 0
    self.skillCount = 0

    self.noSkills = Settings.ClassToolsNoSkills
    self.breakRankEnabled = Settings.ClassToolsGuardianBreakRankLabel


    self:LoadData()

    self.fortification = 0
    self.breakRanksAvailable = false
    self.breakRanksTime = 0

    -- 0 base | 1 after re | 2 after sh | 3 after both
    self.smashingStabeState = 0

    self.duration = 0

    -- Cooldown table

    self.cooldownTable = {
        ["Juggernaut"] = 1091805299,
        ["Guardian's Pledge"] = 1090541178,
        ["Redirect"] = 1091805300,
        ["Warrior's Heart"] = 1090541182,
        ["Litany of Defiance"] = 1091444826,
    }

    -- small coodlowns
    self.smallcooldownTable = {
        ["Charge"] = 1090553762,
        ["Damage Reflection"] = 1091805300,
        ["Bring on the Pain"] = 1090527705,
        ["Stoic"] = 1091668185,
    }

    self.specialSmallcooldownTable = {
        ["Damage Reflection"] = 1091805300,
        ["Bring on the Pain"] = 1090527705,
        ["Stoic"] = 1091668185,
        ["Break Ranks"] = 1091805247,
    }

    -- big cooldowns
    self.bigcooldownTable = {
        ["Juggernaut"] = 1091805299,
        ["Guardian's Pledge"] = 1090541178,
        ["Warrior's Heart"] = 1090541182,
        ["Litany of Defiance"] = 1091444826,
    }

    self.cooldownLabels = {}
    self.activeLabels = {}

    -- Normal skills - 20

        --[[

        Hitting skills - 9

            Guardian's Ward Tactics **
            Sweeping Cut
            Improved Sting
            War-chant **
            Vexing Blow
            Shield-blow
            Smashing Stab **
            Stagger
            Stamp **

        Taunt skills - 3

            Challenge
            Engage
            Fray the Edge

        Utility - 2

            Ignore the Pain
            Turn the Tables

        Cooldowns - 6

            Juggernaut
            Guardian's Pledge
            Warrior's Heart
            Litany of Defiance

            Thrill of Danger
            Catch a Breath **

    ]]

    -- Add break ranks timer
    self.SkillBarSkills = {
        -- Bar 1
        ["Guardian's Ward"] = {3, "0x70003066", 1},
        ["Improved Sting"] ={2, "0x7000F1E1", 1},
        ["Shield-blow"] = {1,"0x7000306F", 1},
        ["Sweeping Cut"] = {6, "0x70003EDE", 1},
        ["Vexing Blow"] = {5, "0x7000308D", 1},
        ["Catch a Breath"] = {10, "0x7000307D", 1},
        ["Stamp"] = {4, "0x70003EE7", 1},
        ["War-chant"] = {8, "0x70036947", 1},
        ["Smashing Stab"] = {9, "0x70036DCD", 1},
        ["Stagger"] = {7, "0x7000D4B3", 1},
        ["Ignore the Pain"] = {11, "0x70021663", 1},
        ["Thrill of Danger"] = {12, "0x700030B4", 1},
        ["Turn the Tables"] = {14, " 0x70003EE8", 1},
        ["Charge"] = {13, "0x7000DD14", 1},

        -- Bar 2

        ["Redirect"] = {7, "0x70036945", 2},
        ["Challenge"] = {4, "0x70003097", 2},
        ["Engage"] = {5, "0x7000D4B2", 2},
        ["Fray the Edge"] = {6, "0x7000D4B5", 2},
        ["Guardian's Pledge"] = {9, "0x700030A4", 2},
        ["Juggernaut"] = {10, "0x70036946", 2},
        ["Warrior's Heart"] = {11, "0x700030AC", 2},
        ["Litany of Defiance"] = {12, "0x7000F095", 2},
        --break ranks

    }

    if self.data == nil then
        self.data = {}
        for key, value in pairs(self.SkillBarSkills) do
            self.data[key] = {true, value[1], value[3]}
        end
    else
        for key, value in pairs(self.data) do
            --ChatOutput(value[1])
            if value[1] == false then
                self.SkillBarSkills[key] = nil
            else
                self.SkillBarSkills[key] = {value[2], self.SkillBarSkills[key][2], value[3]}
            end
        end
    end

    -- forticon IDs  
    self.FortificationTable = {
        --[1090527700] = 0,
        [1091840994] = 1,
        [1091840981] = 2,
        [1091840991] = 3,
        [1091840993] = 4,
        [1091840986] = 5
    }

    -- Skill table
    self.SkillTable = {
        ["Shield-swipe"] = {1, "0x7000305D"},
        ["Shield-taunt"] = {2, "0x70003EE6"},
        ["Bash"] = {3, "0x70003EE1"},
        ["Shield-smash"] = {4, "0x70002EC4"},
        ["Break Ranks"] = {5, nil},

        ["Retaliation"] = {6, "0x70003EE0"},
        ["Whirling Retaliation"] = {7, "0x70003EE4"},
        ["Redirect"] = {8, "0x70036945"},

        ["Catch a Breath"] = {9, "0x7000307D"},
    }

    -- [1] 1 = block 2 = parry [2] tier
    self.ResponseTable = {
        ["Block Response"] = {1, 1},
        ["Shield Swipe"] = {1, 2},
        ["Parry Response"] = {2, 1},
        ["Retaliation"] = {2, 2}
    }

    self.SkillUsageTable = {
        ["Shield-swipe"] = {1, 1},
        ["Shield-taunt"] = {1, 2},
        ["Bash"] = {1, 2},
        ["Shield-smash"] = {1, 3},

        ["Retaliation"] = {2, 1},
        ["Whirling Retaliation"] = {2, 1},
        ["Redirect"] = {2, 2},
    }

    self.SkillIcons = {}

    --self.FortLabel = ClassSkillLabel(self, 0, 0, self.baseSize, self.fortSize, 1090527700, false)


    --Bleed 0x41000083
    -- Color 0x41007E13
    -- Shield  0x41007E90
    -- Knockdown shield 0x4100823E
    -- Stun 0x4100823F
    -- Man line 0x410087B8
    -- SHield and sword 0x4112E312
    -- Yellow break ranks 0x411F5271

    --self.stabLabel = ClassSkillLabel(self.normalSkillBar, 0, 50, self.baseSize, self.fortSize, 1091805247, false)
    --self.bleedLabel = ClassSkillLabel(self.normalSkillBar, 25 + (self.SkillBarSkills["Smashing Stab"][1] - 1) * 32, (self.SkillBarSkills["Smashing Stab"][2] - 1) * 32, self.baseSize, self.baseSize, BloodIcon, true) -- find bleed icon
    --self.stunLabel = ClassSkillLabel(self.normalSkillBar, 25 + (self.SkillBarSkills["Smashing Stab"][1] - 1) * 32, (self.SkillBarSkills["Smashing Stab"][2] - 1) * 32, self.baseSize, self.baseSize, FireShield, true) -- find stun icon
    --self.fMLabel = ClassSkillLabel(self.normalSkillBar, 25 + (self.SkillBarSkills["Smashing Stab"][1] - 1) * 32, (self.SkillBarSkills["Smashing Stab"][2] - 1) * 32, self.baseSize, self.baseSize, CJIconSmalll, true)
    --self.testy = SmashingStabSlot(self.normalSkillBar, 25 + (self.SkillBarSkills["Smashing Stab"][1] - 1) * 32, - 40 + (self.SkillBarSkills["Smashing Stab"][2] - 1) * 32, self.baseSize, self.baseSize, "0x70036DCD")
    self:Load()
end

function GuardianTools:SmashingStabUpdate(action)
    --ChatOutput(action)
    if self.normalSkills["Smashing Stab"] then self.normalSkills["Smashing Stab"]:SetMode(action) end
    ----ChatOutput("SM" .. self.smashingStabeState)
end

function GuardianTools:SetSkillObjects()

    self.FortLabel2 = FortificationIndicator(self, self.width / 2 - 25, 0, self.baseSize, self.fortSize, true) 

    if self.breakRankEnabled and not(self.noSkills) then
        self.BreakRanksLabel = ClassTimerLabel(self.normalSkillBar, 9 + 32 * 7, 32, self.baseSize, self.reactionSize, 0x41139EFF, true, true, 0, 1, 1, false, true, true)
        self.normalSkillBar:AddLabel("Break Ranks", self.BreakRanksLabel, nil, nil)
        self.normalSkills["Break Ranks"] = self.BreakRanksLabel
    end

    self.SkillIcons["Break Ranks"] = ClassTimerLabel(self.ReactionBar, 0, 0, self.baseSize, self.reactionSize, 1091805247, false, true, 0, 1, 1, false, false, true)
    self.ReactionBar:AddLabel("Break Ranks", self.SkillIcons["Break Ranks"], self.SkillTable["Break Ranks"][1], nil)

    self.OutOfCombatLabel = ClassTimerLabel(self.ReactionBar, 0, 0, self.baseSize, self.reactionSize, 0x410D3DE9, false, true, 0, 1, 1, false, false, true)
    self.ReactionBar:AddLabel("Leaving Combat", self.OutOfCombatLabel, 1, nil)

    for key, value in pairs(self.specialSmallcooldownTable) do
        --ChatOutput(key)
        self.SmallCDBar:AddLabel(key, ClassTimerLabel(self.SmallCDBar, 0, 0, self.baseSize, self.reactionSize, value, false, false, 0, 1, 1, true, false, true), 1)
    end

    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()
        ----ChatOutput(name .. item:GetSkillInfo():GetIconImageID())

        self.skillCallbacks[name] = {}

        if self.SkillTable[name] then
            
            self.SkillIcons[name] = ClassSkillSlot(self.ReactionBar, 50 * index, 0, self.baseSize, self.reactionSize, self.SkillTable[name][2], true)
            self.SkillIcons[name]:SetTimer(item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
            self.ReactionBar:AddLabel(name, self.SkillIcons[name], self.SkillTable[name][1], item)
            index = index + 1
        end

        if self.SkillBarSkills[name] and not(self.noSkills) then
            local offset = 9
            if self.SkillBarSkills[name][3] == 1 then offset = 25 end
            --self.normalSkills[name] = ClassTimerLabel(self.normalSkillBar, offset + 32 * (self.SkillBarSkills[name][1] - 1), 32 * (self.SkillBarSkills[name][3] - 1), self.baseSize, self.reactionSize, item:GetSkillInfo():GetIconImageID(), true, true, 0, 1, 1, false)
            --self.normalSkillBar:AddLabel(name, self.normalSkills[name], nil, item)
            if name == "Smashing Stab" then
                self.normalSkills[name] = SmashingStabSlot(self.normalSkillBar, offset + 32 * (self.SkillBarSkills[name][1] - 1), 32 * (self.SkillBarSkills[name][3] - 1), self.baseSize, self.reactionSize, self.SkillBarSkills[name][2])
            else
                self.normalSkills[name] = ClassSkillSlot(self.normalSkillBar, offset + 32 * (self.SkillBarSkills[name][1] - 1), 32 * (self.SkillBarSkills[name][3] - 1), self.baseSize, self.reactionSize, self.SkillBarSkills[name][2])
            end
            self.normalSkillBar:AddLabel(name, self.normalSkills[name], nil, item)
            self.normalSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())

            if self.SkillBarSkills[name][3] == 1 then
                self.skillCount = self.skillCount + 1
            elseif self.SkillBarSkills[name][3] == 2 then
                self.specialSkillCount = self.specialSkillCount + 1
            end
        end
    
        if self.smallcooldownTable[name] then
            self.SmallCDBar:AddLabel(name, ClassTimerLabel(self.SmallCDBar, 0, 0, self.baseSize, self.reactionSize, item:GetSkillInfo():GetIconImageID(), false, false, 0, 1, 1, true, false, true), 1)
        end

        if self.bigcooldownTable[name] then
            self.BigCDBar:AddLabel(name, ClassTimerLabel(self.BigCDBar, 0, 0, self.baseSize, self.reactionSize, item:GetSkillInfo():GetIconImageID(), false, false, 0, 1, 1, true, false, true), 1)
        end
    end

    if Settings.ClassToolsGuardianBreakRankYBar == 1 then
        self.skillCount = self.skillCount + 1
    elseif Settings.ClassToolsGuardianBreakRankYBar == 2 then
        self.specialSkillCount = self.specialSkillCount + 1
    end

    self.SkillBarSkills["Break Ranks"] = {Settings.ClassToolsGuardianBreakRankXPrio, nil, Settings.ClassToolsGuardianBreakRankYBar}

    local padding = (self.width - self.skillCount * 32 ) / 2

    local positionCounter = 0
    for key, value in spairs(self.normalSkills, function(t,a,b) return self.SkillBarSkills[b][1] > self.SkillBarSkills[a][1] end) do
        if self.SkillBarSkills[key][3] == 1 then
            value:SetPosition(padding + positionCounter * 32, 0)
            positionCounter = positionCounter + 1
        end
    end

    local specialPadding = (self.width - self.specialSkillCount * 32 ) / 2

    positionCounter = 0
    for key, value in spairs(self.normalSkills, function(t,a,b) return self.SkillBarSkills[b][1] > self.SkillBarSkills[a][1] end) do
        if self.SkillBarSkills[key][3] == 2 then
            value:SetPosition(specialPadding + positionCounter * 32, 32)
            positionCounter = positionCounter + 1
        end
    end

    -- Handle initial state
    for i = 1, self.effectList:GetCount(), 1 do
        local name = self.effectList:Get(i):GetName()

        local response = self.ResponseTable[name]
        if response then
            if response[1] == 1 then self:HandleBlockUpdate(response[2]) end
            if response[1] == 2 then self:HandleParryUpdate(response[2]) end
        end

        local effectIcon = self.effectList:Get(i):GetIcon()

        if self.FortificationTable[effectIcon] then
            self.fortification = self.FortificationTable[effectIcon]
            self.FortLabel2:ChangeStacks( self.fortification)
            --self.FortLabel:ChangeIcon(effectIcon)
        end
    end
end

function GuardianTools:HandleBlockUpdate(state)
    if state == 1 then
        --ChatOutput("Shield-Swipe")
        self.ReactionBar:ToggleLabel("Shield-swipe", true, 6)
        --self.SkillIcons["Shield-swipe"]:SetVisible(true)
        -- Refresh timer
    elseif state == 2 then
        --self.SkillIcons["Shield-swipe"]:SetVisible(false)
        self.ReactionBar:ToggleLabel("Bash", true, 6)
        self.ReactionBar:ToggleLabel("Shield-taunt", true, 6)
        if self.fortification == 5 and Turbine.Engine.GetGameTime() - self.breakRanksTime > 60 then
            self.ReactionBar:ToggleLabel("Break Ranks", true, 6)
        end
        --self.SkillIcons["Bash"]:SetVisible(true)
        --self.SkillIcons["Shield-taunt"]:SetVisible(true)
        --ChatOutput("Bash")
        --ChatOutput("Taunt")
        -- Refresh timer

        -- Update stab
        self:SmashingStabUpdate(2)
    elseif state == 3 then
        --ChatOutput("Smash")
        self.ReactionBar:ToggleLabel("Shield-smash", true, 6)
        --self.SkillIcons["Shield-smash"]:SetVisible(true)
        -- Refresh timer
    end
end

function GuardianTools:HandleBlockRemovalUpdate(state)
    if state == 1 then
        self.ReactionBar:ToggleLabel("Shield-swipe", nil)
    elseif state == 2 then
        self.ReactionBar:ToggleLabel("Bash", nil)
        self.ReactionBar:ToggleLabel("Shield-taunt", nil)
    elseif state == 3 then
        -- Add timeout
        self.ReactionBar:ToggleLabel("Shield-smash", nil)
    end
end

function GuardianTools:HandleParryRemovalUpdate(state)
    if state == 1 then
        self.ReactionBar:ToggleLabel("Retaliation", nil)
        self.ReactionBar:ToggleLabel("Whirling Retaliation", nil)
    elseif state == 2 then
        self.ReactionBar:ToggleLabel("Redirect", nil)
    elseif state == 3 then
    end
end

function GuardianTools:HandleParryUpdate(state)
    if state == 1 then
        self.ReactionBar:ToggleLabel("Retaliation", true, 6)
        self.ReactionBar:ToggleLabel("Whirling Retaliation", true, 6)
        -- Refresh timer
    elseif state == 2 then
        self.ReactionBar:ToggleLabel("Redirect", true, 6)
        -- Refresh timer

        -- Update stab
        self:SmashingStabUpdate(1)
    elseif state == 3 then
    end
end

function GuardianTools:ExecuteUpdate(delta)
    self.duration = self.duration - delta
    --ChatOutput(self.duration)
    if self.duration < 0 then
        self:SmashingStabUpdate(0)
        self.fortification = 0
        self.FortLabel2:ChangeStacks(0)
        Updater:UnSubscribe(self)
    end
end

function GuardianTools:RemoveCallbacks()
    --player callbacks
    for key, value in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, key, value)
    end

    for key, value in pairs(self.effectCallbacks) do
        RemoveCallback(self.effectList, key, value)
    end

    for key, value in pairs(self.skillCallbacks) do
        for _, callback in pairs(value) do
            RemoveCallback(self.skillsLUT[key], "ResetTimeChanged", callback)
        end
    end

    collectgarbage()
end

function GuardianTools:SetCallbacks()

    -- broken
    self.ClassAttr.IsBlockTier1AvailableChanged = function()
        --ChatOutput("1")
    end

    self.ClassAttr.IsBlockTier2AvailableChanged = function()
        --ChatOutput("2")
        if self.ClassAttr:IsBlockTier2Available() then self:HandleBlockUpdate(2) end
    end

    self.ClassAttr.IsBlockTier3AvailableChanged = function()
        --ChatOutput("3")
        if self.ClassAttr:IsBlockTier3Available() then self:HandleBlockUpdate(3) end
    end

    -- broken
    self.ClassAttr.IsParryTier1AvailableChanged = function()
        --ChatOutput("p1")
        if self.ClassAttr:IsParryTier1Available() then self:HandleParryUpdate(1) end
    end

    self.ClassAttr.IsParryTier2AvailableChanged = function()
        --ChatOutput("p2")
        if self.ClassAttr:IsParryTier2Available() then self:HandleParryUpdate(2) end
    end

    -- Red memes
    self.ClassAttr.IsParryTier3AvailableChanged = function()
        --ChatOutput("p3")
    end

    self.playerCallbacks["InCombatChanged"] = AddCallback(self.player, "InCombatChanged",
    function(sender, args)
        if not(self.player:IsInCombat()) then
            self.duration = 9
            self.ReactionBar:ToggleLabel("Leaving Combat", true, 9)
            Updater:Subscribe(self)
        end
    end)

    
    -- Handle effect updates
    self.effectCallbacks["EffectAdded"] = AddCallback(self.effectList, "EffectAdded", 
    function(sender, args)
        local effect = sender:Get(args.Index) 

        local effectName = effect:GetName()
        if effectName == "Block Response" then
            self:HandleBlockUpdate(1)
        elseif effectName == "Parry Response" then
            self:HandleParryUpdate(1)
        end

        if effectName == "Break Ranks" then
            --ChatOutput("BR")
            if not(self.noSkills) then self.normalSkillBar:SetLabelTimer("Break Ranks", 60, 60) end
            self.breakRanksTime = Turbine.Engine.GetGameTime()
            self.ReactionBar:ToggleLabel("Break Ranks", nil)
            self.SmallCDBar:ToggleLabel("Break Ranks", true, 15)
        end

        local effectIcon = effect:GetIcon()

        --ChatOutput(effect:GetName() .. effect:GetIcon())

        if self.FortificationTable[effectIcon] then
            self.fortification = self.FortificationTable[effectIcon]
            self.FortLabel2:ChangeStacks( self.FortificationTable[effectIcon])
            --self.FortLabel:ChangeIcon(effectIcon)
        elseif effectName == "Litany of Defiance" or (effectName == "Break Ranks" and self.fortification == 5) then
            --self.FortLabel:ChangeIcon(1090527700)
            self.fortification = 0
            self.FortLabel2:ChangeStacks(0)
        end

        if self.smallcooldownTable[effectName] and effect:GetDuration() < 99999 then
            self.SmallCDBar:ToggleLabel(effectName, true, effect:GetDuration())
        end

        if self.bigcooldownTable[effectName] and self.bigcooldownTable[effectName] == effectIcon then
            self.BigCDBar:ToggleLabel(effectName, true, effect:GetDuration())
        end
    end)

    -- [[
    self.effectCallbacks["EffectRemoved"] = AddCallback(self.effectList, "EffectRemoved", 
    function(sender, args)
        --[[
        --local effect = sender:Get(args.Index) 
        local effectName = args.Effect:GetName()

        local response = self.ResponseTable[effectName]
        if response then
            if response[1] == 1 then
                self:HandleBlockRemovalUpdate(response[2])
            elseif response[1] == 2 then
                self:HandleParryRemovalUpdate(response[2])
                -- parry
            end
        end
        --]]

        if args.Effect:GetName() == "Stoic" then
            self.SmallCDBar:ToggleLabel("Stoic", nil)
        end

        if self.FortificationTable[args.Effect:GetIcon()] and not(self.player:IsInCombat()) then
            --:ChangeIcon(1090527700)
            self.FortLabel2:ChangeStacks( 0)
        end
    end)

    -- skill callbacks
    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()
        ----ChatOutput(name .. item:GetSkillInfo():GetIconImageID())

        self.skillCallbacks[name] = {}

        if self.SkillTable[name] and not(self.noSkills) then
            self.skillsLUT[name] = item
           table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.SkillIcons[name]:SetTimer(item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
            end))
        end

        if self.SkillBarSkills[name] and not(self.noSkills) then
            self.skillsLUT[name] = item
           table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.normalSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
            end))
        end

        if name == "Catch a Breath" then
            self.skillsLUT[name] = item
           table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                if item:GetResetTime() - Turbine.Engine.GetGameTime() > item:GetCooldown() - 0.5 then
                    self:HandleBlockRemovalUpdate(1)
                    self:HandleParryRemovalUpdate(1) 
                end 
            end))
        end

        if self.SkillUsageTable[name] then
            local value = self.SkillUsageTable[name]
            if value[1] == 1 then
                self.skillsLUT[name] = item
               table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                    --ChatOutput("SkillRemoval")
                    if item:GetResetTime() - Turbine.Engine.GetGameTime() > item:GetCooldown() - 0.5 then
                        self:HandleBlockRemovalUpdate(value[2]) 
                    end 
                end))
            elseif value[1] == 2 then
                self.skillsLUT[name] = item
               table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                    --ChatOutput("SkillRemoval")
                    if item:GetResetTime() - Turbine.Engine.GetGameTime() > item:GetCooldown() - 0.5 then
                        self:HandleParryRemovalUpdate(value[2]) 
                    end 
                end))
            end
        end

        if name == "Smashing Stab" then
            self.skillsLUT[name] = item
           table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                --ChatOutput("SkillRemoval")
                --ChatOutput(item:GetResetTime())
                if item:GetResetTime() - Turbine.Engine.GetGameTime() > item:GetCooldown() - 0.5 then
                    self:SmashingStabUpdate(0) 
                end 
            end))
        end
    end
    --]]
end

function GuardianTools:LoadData()
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.effectList = self.player:GetEffects()
    self.ClassAttr = self.player:GetClassAttributes()
    self.trainedSkills = self.player:GetTrainedSkills()
end

function GuardianTools:RemoveSkillObjects()
    self.ReactionBar:Unload()
    self.SmallCDBar:Unload()
    self.BigCDBar:Unload()
    self.normalSkillBar:Unload()
    self.FortLabel2:Unload()

    self.SkillIcons = {}
    self.normalSkills = {}

    self.specialSkillCount = 0
    self.skillCount = 0

    collectgarbage()


end

function GuardianTools:ParseUpdate(message)
end

function GuardianTools:ToggleMove()
    self.moveBox:ToggleMove()
end

function GuardianTools:GetOptions(parent, x, y)
    local container = Turbine.UI.Control()
    container:SetParent(parent)
    container:SetPosition(x, y)
    container:SetSize(530 + 4, 100 + 4)
    container:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(container)
    SingleBackground:SetPosition(2, 2)
    SingleBackground:SetSize(530, 100)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox2 = Turbine.UI.Lotro.CheckBox();
    EffectBox2:SetParent(SingleBackground)
    EffectBox2:SetPosition(10, 50);
    EffectBox2:SetSize(200,20);
    EffectBox2:SetChecked(Settings.ClassToolsNoSkills)
    EffectBox2:SetText("Disable skill bars");
    EffectBox2:SetVisible(true);

    EffectBox2.CheckedChanged = function()
        Settings.ClassToolsNoSkills = EffectBox2:IsChecked()
    end

    local ScaleLabel = Turbine.UI.Label()
    ScaleLabel:SetParent(SingleBackground)
    ScaleLabel:SetSize(300, 30)
    ScaleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    ScaleLabel:SetPosition(10, 10)
    ScaleLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    ScaleLabel:SetText("Break Ranks: X-axis priority / Y bar") 

    local BarScaleBar = Turbine.UI.Lotro.TextBox()
    BarScaleBar:SetParent(SingleBackground)
    BarScaleBar:SetSize(50, 30)
    BarScaleBar:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BarScaleBar:SetPosition(280, 5)
    BarScaleBar:SetText(Settings.ClassToolsGuardianBreakRankXPrio)

    local BarScaleBar1 = Turbine.UI.Lotro.TextBox()
    BarScaleBar1:SetParent(SingleBackground)
    BarScaleBar1:SetSize(50, 30)
    BarScaleBar1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BarScaleBar1:SetPosition(340, 5)
    BarScaleBar1:SetText(Settings.ClassToolsGuardianBreakRankYBar)

    local Button2 = Turbine.UI.Lotro.Button()
    Button2:SetParent(SingleBackground)
    Button2:SetSize(80, 20)
    Button2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    Button2:SetMouseVisible(true)
    Button2:SetPosition(400, 10)
    Button2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    Button2:SetText("Save")

    Button2.Click = function()
        Settings.ClassToolsGuardianBreakRankXPrio = tonumber(BarScaleBar:GetText())
        Settings.ClassToolsGuardianBreakRankYBar = tonumber(BarScaleBar1:GetText())
    end

    local EffectBox1 = Turbine.UI.Lotro.CheckBox();
    EffectBox1:SetParent(SingleBackground)
    EffectBox1:SetPosition(10, 30);
    EffectBox1:SetSize(200,20);
    EffectBox1:SetChecked(Settings.ClassToolsGuardianBreakRankLabel)
    EffectBox1:SetText("Break ranks skill box");
    EffectBox1:SetVisible(true);

    EffectBox1.CheckedChanged = function()
        Settings.ClassToolsGuardianBreakRankLabel = EffectBox1:IsChecked()
    end

end

function GuardianTools:GetData()
    return self.data
end

function GuardianTools:Load()
    self:SetSkillObjects()
    self:SetCallbacks()
end

function GuardianTools:Unload()
    self:RemoveCallbacks()
    self:RemoveSkillObjects()
end

function GuardianTools:Reload()
    self:Unload()
    self:Load()
end

function GuardianTools:ChangeData(key, value)
    self.data[key] = value
end


-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

ClassSkillLabel = class(Turbine.UI.Window)
function ClassSkillLabel:Constructor(parent, x, y, base, normal, baseIcon, visible)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = normal

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.base, self.base)
    self:SetStretchMode(1)
    self:SetVisible(visible)
    self:SetMouseVisible(false)

    self:ChangeIcon(baseIcon)
    --self:SetZOrder(99)
end

function ClassSkillLabel:ChangeIcon(ID)
    self:SetSize(self.base, self.base)
    self:SetBackground(ID)
    self:SetSize(self.normal, self.normal)
end

function ClassSkillLabel:ToggleVisible(value)
    self:SetVisible(value)
    self.IconLabel:SetVisible(value)
end

function ClassSkillLabel:Unload()
    self:SetParent(nil)
    self = nil
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------


ClassTimerLabel = class(Turbine.UI.Window)
function ClassTimerLabel:Constructor(parent, x, y, base, normal, baseIcon, visible, reverse, duration, normalOpacity, usageOpacity, hide, shade, text)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = normal
    self.reverse = reverse
    self.normalOpacity = normalOpacity
    self.usageOpacity = usageOpacity
    self.hide = hide
    self.shade = shade
    self.text = text

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.normal, self.normal)
    self:SetVisible(visible)
    self:SetOpacity(normalOpacity)

    self.currentNumber = -1
    self.currentPercentage = 0

    self.baseImageID = 0x41007E35;

    self.IconLabel = Turbine.UI.Label()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(self.base, self.base)
    self.IconLabel:SetStretchMode(1)
    self.IconLabel:SetBackground(baseIcon)
    self.IconLabel:SetSize(self.normal, self.normal)

    if self.shade then
        self.elapsedOverlay = Turbine.UI.Control();
        self.elapsedOverlay:SetStretchMode( 1 );
        self.elapsedOverlay:SetMouseVisible( false );
        --self.elapsedOverlay:SetZOrder( 99 );
        self.elapsedOverlay:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
        self.elapsedOverlay:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
        self.elapsedOverlay:SetParent( self );
        self.elapsedOverlay:SetPosition(-1, -1)
        self.elapsedOverlay:SetSize(self.normal + 2, self.normal + 2)
    end
    
    if self.text then
        self.textLabel = Turbine.UI.Label()
        self.textLabel:SetParent(self)
        self.textLabel:SetSize(self.normal, self.normal)
        self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
        self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
        self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        self.textLabel:SetMouseVisible(false)
    end

    -- Add timer overlay

    self.startTime = Turbine.Engine.GetGameTime()
end

function ClassTimerLabel:SetTimer(timer, maxTimer)
    if maxTimer then
        self.overlaydDuration = maxTimer
        self.startTime = Turbine.Engine.GetGameTime() - (maxTimer - timer)
    else
        self.overlaydDuration = timer
        self.startTime = Turbine.Engine.GetGameTime()
    end
    self.duration = timer
    self:SetOpacity(self.usageOpacity)

    --Updater:Subscribe(self)
end

function ClassTimerLabel:ExecuteUpdate(delta)

    self.duration = self.duration - delta
    if self.duration < 0 then 
        --Updater:UnSubscribe(self)
        self:SetOpacity(self.normalOpacity)
        if self.hide then self:SetVisible(false) end 

        if self.text then
            self.textLabel:SetText("")
        end
        return true
    end

    if self.shade then

        local percentComplete = math.floor(60 * (Turbine.Engine.GetGameTime() - self.startTime) / self.overlaydDuration)
        if self.reverse then
            percentComplete = 60 - percentComplete
        end

        if self.currentPercentage ~= percentComplete then 

            self.currentPercentage = percentComplete

            local imageId = self.baseImageID + self.currentPercentage            

            self.elapsedOverlay:SetStretchMode( 3 );
            self.elapsedOverlay:SetSize( 32, 32 );
            self.elapsedOverlay:SetBackground( imageId );
            self.elapsedOverlay:SetStretchMode( 1 );
            self.elapsedOverlay:SetSize( self.normal + 2, self.normal + 2);
        end
    end

    local newNumber = math.round(self.duration)
    if newNumber == self.currentNumber then return end

    self.currentNumber = newNumber

    if self.text then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText(self.currentNumber)
    end
end

function ClassTimerLabel:ToggleVisible(value)
    self:SetVisible(value)
    self.IconLabel:SetVisible(value)
end

function ClassTimerLabel:Unload()
    self.IconLabel:SetParent(nil)
    if self.textLabel then self.textLabel:SetParent(nil) end
    if self.elapsedOverlay then self.elapsedOverlay:SetParent(nil) end
    self:SetParent(nil)
    self = nil
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

ClassSkillSlot = class(Turbine.UI.Window)
function ClassSkillSlot:Constructor(parent, x, y, base, normal, skill, hideOnCreation)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = 35
    self.reverse = reverse
    self.normalOpacity = normalOpacity
    self.usageOpacity = usageOpacity
    self.hideOnCreation = hideOnCreation

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.normal, self.normal)
    self:SetVisible(true)

    self.baseImageID = 0x41007E35;

    self.currentNumber = -1

    self.IconLabel = Turbine.UI.Lotro.Quickslot()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(self.normal, self.normal)
    --self.IconLabel:SetBackColor(GetRandomColour())
    self.IconLabel:SetPosition(-3, -3)
    self.shortcut = Turbine.UI.Lotro.Shortcut(6, skill)
    self.IconLabel:SetShortcut(self.shortcut)
    if self.hideOnCreation then
        self.IconLabel:SetVisible(false)
        --ChatOutput("X")
    end
    --self.IconLabel:SetVisible(false)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(self.normal, self.normal)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetPosition(-2, -2)

    --self.fMLabel = ClassSkillLabel(self, 0, 0, base, base, CJIconSmalll, true)

    self.IconLabel.ShortcutChanged = function()
        ChatOutput(self.IconLabel:GetShortcut():GetData())
    end


    self.duration = 0
    --self.textLabel:SetText("0")
end

function ClassSkillSlot:ToggleVisible(value)
    self:SetVisible(value)
    self.IconLabel:SetVisible(value)
end

function ClassSkillSlot:SetTimer(timer, maxTimer)
    self.duration = timer
end

function ClassSkillSlot:ExecuteUpdate(delta)
    self.duration = self.duration - delta

    local newNumber = math.round(self.duration)
    if newNumber == self.currentNumber then return end

    self.currentNumber = newNumber

    if self.duration < 0 then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText("")
        return true
    end
    self.textLabel:SetStretchMode(nil)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetText(self.currentNumber)
    
end

function ClassSkillSlot:Unload()
    self.shortcut = nil
    self.IconLabel:SetParent(nil)
    self.textLabel:SetParent(nil)
    self:SetParent(nil)
    self = nil
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

SmashingStabSlot = class(Turbine.UI.Window)
function SmashingStabSlot:Constructor(parent, x, y, base, normal, skill)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = 35
    self.reverse = reverse
    self.normalOpacity = normalOpacity
    self.usageOpacity = usageOpacity
    self.hide = hide

    self.smashingStabeState = 0

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.normal, self.normal)
    self:SetVisible(true)

    self.currentNumber = -1

    self.baseImageID = 0x41007E35;

    self.IconLabel = Turbine.UI.Lotro.Quickslot()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(self.normal, self.normal)
    --self.IconLabel:SetBackColor(GetRandomColour())
    self.IconLabel:SetPosition(-3, -3)
    self.IconLabel:SetShortcut(Turbine.UI.Lotro.Shortcut(6, skill))

    self.fMLabel = ClassSkillLabel(self, 0, 0, base, 32, CJIconSmalll, false)
    self.stunLabel = ClassSkillLabel(self, 12, 0, 32, 20, 0x4100823F, false)
    self.bleedLabel = ClassSkillLabel(self, 0, 0, 32, 20, 0x41000083, false)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(self.normal, self.normal)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetStretchMode(1)

    --Bleed 0x41000083
    -- Color 0x41007E13
    -- Shield  0x41007E90
    -- Knockdown shield 0x4100823E
    -- Stun 0x4100823F
    -- Man line 0x410087B8
    -- Guard stance 0x410087B8
    -- Brown shield 0x410087B8
    -- SHield and sword 0x4112E312
    -- Yellow break ranks 0x411F5271

    self.duration = 0
    --self.textLabel:SetText("0")
end

function SmashingStabSlot:SetTimer(timer, maxTimer)
    self.duration = timer
end

function SmashingStabSlot:ExecuteUpdate(delta)
    self.duration = self.duration - delta

    local newNumber = math.round(self.duration)
    if newNumber == self.currentNumber then return end

    self.currentNumber = newNumber

    if self.duration < 0 then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText("")
        return true
    end
    self.textLabel:SetStretchMode(nil)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetText(self.currentNumber)
    
end

function SmashingStabSlot:SetMode(action)

    if action == 0 then 
        self.smashingStabeState = 0 
        self.bleedLabel:SetVisible(false)
        self.stunLabel:SetVisible(false)
        self.fMLabel:SetVisible(false)
        return
    end

    if self.smashingStabeState == 3 then return end

    if action == 1 then
        --CJ
        if self.smashingStabeState == 2 then
            self.smashingStabeState = 3
        else
            -- Bleed
            self.smashingStabeState = 1
            self.bleedLabel:SetVisible(true)
        end
    elseif action == 2 then
        -- CJ
        if self.smashingStabeState == 1 then
            self.smashingStabeState = 3
        else
            -- Stun
            self.smashingStabeState = 2
            self.stunLabel:SetVisible(true)
        end
    end

    if self.smashingStabeState == 3 then
        self.bleedLabel:SetVisible(false)
        self.stunLabel:SetVisible(false)
        self.fMLabel:SetVisible(true)
    end
end

function SmashingStabSlot:ToggleVisible(value)
    self:SetVisible(value)
    self.IconLabel:SetVisible(value)
end

function SmashingStabSlot:Unload()
    self.fMLabel:Unload()
    self.stunLabel:Unload()
    self.bleedLabel:Unload()
    self.IconLabel:SetParent(nil)
    self.textLabel:SetParent(nil)
    self:SetParent(nil)
    self = nil
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

FortificationIndicator = class(Turbine.UI.Window)
function FortificationIndicator:Constructor(parent, x, y, base, normal, visible)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = normal

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.normal, self.normal)
    self:SetStretchMode(1)
    self:SetVisible(visible)
    self:SetMouseVisible(false)
    --self:SetBackColor(GetRandomColour())

    self.background = Turbine.UI.Label()
    self.background:SetParent(self)
    self.background:SetSize(self.normal, self.normal)
    self.background:SetBackground(FireShieldBig)
    self.background:SetMouseVisible(false)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(self.normal, self.normal)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetForeColor(Turbine.UI.Color(0.2,0.2,0.2))
    self.textLabel:SetText("0")
    self.textLabel:SetMouseVisible(false)
end

function FortificationIndicator:ChangeStacks(number)
    self.textLabel:SetText(number)
end

function FortificationIndicator:ToggleVisible(value)
    self:SetVisible(value)
    self.IconLabel:SetVisible(value)
end

function FortificationIndicator:Unload()
    self.background:SetParent(nil)
    self.textLabel:SetParent(nil)
    self:SetParent(nil)
    self = nil
end


-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

DynamicSkillBar = class(Turbine.UI.Control)
function DynamicSkillBar:Constructor(parent, x, y, width, height, labelSize, sortMethod, hide)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(width, height)
    self:SetMouseVisible(false)
    --self:SetBackColor(GetRandomColour())

    self.width = width
    self.labelSize = labelSize

    self.skills = {}
    self.classLabels = {}
    self.activeClassLabels = {}
    self.timerLabels = {}
    self.skillLUT = {}

    self.activeTimerCount = 0

    self.sortTable = {}

    self.activeCount = 0

    self.hide = not(hide)

    -- Make efficient sorting
    if sortMethod == 1 then -- Left
        self.SortLabels = function()
            local counter = 0
            for key,_ in spairs(self.activeClassLabels, function(t,a,b) return self.sortTable[b] > self.sortTable[a] end) do
                self.classLabels[key]:SetPosition(counter * self.labelSize, 0)
                counter = counter + 1
            end
        end
    elseif sortMethod == 2 then -- Center
        self.SortLabels = function()
            local counter = 0
            for key,_ in spairs(self.activeClassLabels, function(t,a,b) return self.sortTable[b] > self.sortTable[a] end) do
                self.classLabels[key]:SetPosition(self.width / 2 - self.labelSize / 2 * self.activeCount + counter * self.labelSize, 0)
                counter = counter + 1
            end
        end
    elseif sortMethod == 3 then -- Right
        self.SortLabels = function()
            local counter = 0
            for key,_ in spairs(self.activeClassLabels, function(t,a,b) return self.sortTable[b] > self.sortTable[a] end) do
                self.classLabels[key]:SetPosition(self.width - (counter + 1) * self.labelSize, 0)
                counter = counter + 1
            end
        end
    elseif sortMethod == 4 then
        self.SortLabels = function()

        end
    end

end

function DynamicSkillBar:AddLabel(skill, label, priority, skillObject)
    self.sortTable[skill] = priority

    self.classLabels[skill] = label
    self.skillLUT[skill] = skillObject
end

function DynamicSkillBar:ToggleLabel(skill, value, time)

    -- Set visible
    if value then 
        --ChatOutput("Checking Active")
        -- Check if already visible
        if self.activeClassLabels[skill] then
            -- Correct timer and return
            if time then self:SetLabelTimer(skill, time) end
            return
        end

        -- Otherwise set visible and update book keeping
        self.activeClassLabels[skill] = true
        --for key, value in pairs(self.classLabels) do --ChatOutput(key) end
        self.classLabels[skill]:ToggleVisible(true)
        self.activeCount = self.activeCount + 1
        if time then self:SetLabelTimer(skill, time) end

    else -- Disable label

        -- Check if already disabled
        if self.activeClassLabels[skill] == nil then 
            return 
        end

        --ChatOutput(skill .. "Disable")
        self.classLabels[skill]:ToggleVisible(self.hide)
        self.activeCount = self.activeCount - 1
        self.activeClassLabels[skill] = nil

        if self.timerLabels[skill] then
            self.activeTimerCount = self.activeTimerCount - 1
            self.timerLabels[skill] = nil
            if self.activeTimerCount <= 0 then
                Updater:UnSubscribe(self)
            end
        end
    end

    self:SortLabels()

    --[[
    if self.activeClassLabels[skill] ~= value then
        self.classLabels[skill]:ToggleVisible(value)
        if value then
            self.activeCount = self.activeCount + 1
            self.activeClassLabels[skill] = value
        else
            self.activeCount = self.activeCount - 1 
            self.activeClassLabels[skill] = nil
        end
    end

    if time == true and self.skillLUT[skill]:GetResetTime() > 0 then
        self:SetLabelTimer(skill, self.skillLUT[skill]:GetResetTime() - Turbine.Engine.GetGameTime(), self.skillLUT[skill]:GetCooldown())
    elseif time and time ~= true and time > 0 then
        self:SetLabelTimer(skill, time)
    end
    --]]
end

function DynamicSkillBar:SetLabelTimer(skill, time, maxTime)

    if time <= 0 then return end

    if not(self.timerLabels[skill]) then
        self.activeTimerCount = self.activeTimerCount + 1
    end

    self.classLabels[skill]:SetTimer(time, maxTime)
    self.activeClassLabels[skill] = true
    self.timerLabels[skill] = true

    Updater:Subscribe(self)
end

function DynamicSkillBar:ExecuteUpdate(delta)
    for key, value in pairs(self.timerLabels) do
        if self.classLabels[key]:ExecuteUpdate(delta) then
            self:ToggleLabel(key, nil)
            --if not(self.classLabels[key]:IsVisible()) then self:ToggleLabel(key) end
        end
    end
    --ChatOutput(self.activeTimerCount)
    --ChatOutput(self.activeCount)
    --ChatOutput(self.activeTimerCount)
    --ChatOutput("--")

    if self.activeTimerCount <= 0 then
        Updater:UnSubscribe(self)
    end
end

function DynamicSkillBar:Unload()

    for key, value in pairs(self.classLabels) do
        value:Unload()
    end
    
    self.skills = {}
    self.classLabels = {}
    self.activeClassLabels = {}
    self.timerLabels = {}
    self.skillLUT = {}
    self.sortTable = {}
    self.activeTimerCount = 0
    self.activeCount = 0
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

ThresholdBubbleTimer = class(Turbine.UI.Window)
function ThresholdBubbleTimer:Constructor()
    Turbine.UI.Window.Constructor(self)

    self:SetPosition(Settings.ThresX, Settings.ThresY)
    self:SetSize(32, 32)
    --self:SetBackground(1091668185)
    self:SetVisible(false)

    self.background = Turbine.UI.Window()
    self.background:SetParent(self)
    self.background:SetSize(32, 32)
    self.background:SetBackground(1091668185)
    self.background:SetVisible(true)
    self.background:SetOpacity(0.8)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(32, 32)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetVisible(true)

    self.duration = 0
    self.currentNumber = 0
    self.callback = nil

    self.effectList = Turbine.Gameplay.LocalPlayer.GetInstance():GetEffects()
    --1091668185

    self:SetCallbacks()

    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(32, 32)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end
end

function ThresholdBubbleTimer:ExecuteUpdate(delta)
    self.duration = self.duration - delta

    local newNumber = math.round(self.duration)
    if newNumber == self.currentNumber then return end

    self.currentNumber = newNumber

    if self.duration < 0 then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText("")
        self:SetVisible(false)
        Updater:UnSubscribe(self)
        return true
    end
    self.textLabel:SetStretchMode(nil)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetText(self.currentNumber)
end

function ThresholdBubbleTimer:SetCallbacks()
    self.callback = AddCallback(self.effectList, "EffectAdded", 
    function(sender, args)
        local effect = sender:Get(args.Index) 

        if sender:Get(args.Index):GetName() == "Threshold Morale Bubble" then --Threshold Morale Bubble
            self.duration = 30
            self:SetVisible(true)
            Updater:Subscribe(self)
        end
    end)
end

function ThresholdBubbleTimer:RemoveCallbacks()
    RemoveCallback(self.effectList, "EffectAdded", self.callback)
end

function ThresholdBubbleTimer:Close()
    self:RemoveCallbacks()
    Settings.ThresX, Settings.ThresY = self:GetPosition()
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

PortentTimer = class(Turbine.UI.Window)
function PortentTimer:Constructor(name, type)
    Turbine.UI.Window.Constructor(self)

    self.name = name

    self:SetPosition(Settings["ItemPositions"][self.name].X, Settings["ItemPositions"][self.name].Y)
    self:SetSize(32, 32)
    --self:SetBackground(1091668185)
    self:SetVisible(false)

    self.background = Turbine.UI.Window()
    self.background:SetParent(self)
    self.background:SetSize(32, 32)
    self.background:SetBackground(0x4110B67F)
    self.background:SetVisible(true)
    self.background:SetOpacity(0.8)

    self.typeLabel = Turbine.UI.Control()
    self.typeLabel:SetParent(self)
    self.typeLabel:SetSize(32, 32)
    if type == 1 then -- DPS
        self.typeLabel:SetBackground(0x4111D248)
    elseif type == 2 then -- Heal
        self.typeLabel:SetBackground(0x4111D246)
    else -- Shield
        self.typeLabel:SetBackground(0x4111D247)
    end

    self.typeLabel:SetStretchMode(1)
    self.typeLabel:SetSize(24,24)
    self.typeLabel:SetPosition(4, 0)

    self.textLabel = Turbine.UI.Label()
    self.textLabel:SetParent(self)
    self.textLabel:SetSize(32, 32)
    self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textLabel:SetMouseVisible(false)
    self.textLabel:SetStretchMode(1)
    self.textLabel:SetVisible(true)

    self.activeLabel = Turbine.UI.Label()
    self.activeLabel:SetParent(self)
    self.activeLabel:SetSize(32, 32)
    self.activeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.activeLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.activeLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.activeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.activeLabel:SetMouseVisible(false)
    self.activeLabel:SetStretchMode(1)
    self.activeLabel:SetVisible(true)
    self.activeLabel:SetForeColor(Turbine.UI.Color(0.9, 0.1, 1, 0.1))

    self.duration = 0
    self.currentNumber = 0
    self.activeTime = 0
    self.callback = nil

    self.effectList = Turbine.Gameplay.LocalPlayer.GetInstance():GetEffects()
    --1091668185
    -- Bauble icon 0x4110B67F
    -- Heal 0x4111D246
    -- Shield 0x4111D247
    -- DPS 0x4111D248
    -- Support 0x4111D245
    -- CHeckmark 0x4111D245

    self:SetCallbacks()

    self.MoveBox = Turbine.UI.Window()
    self.MoveBox:SetParent(self)
    self.MoveBox:SetSize(32, 32)
    self.MoveBox:SetVisible(true)

    self.Moving = false

    self.MoveBox.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.MoveBox.MouseUp = function()
        self.Moving = false
    end

    self.MoveBox.MouseMove = function(sender,args)
        if self.Moving then
        local newLeft = self:GetLeft() - (self.MoveX - args.X)
        local newTop = self:GetTop() - (self.MoveY - args.Y)
        self:SetPosition(newLeft,newTop)
        end
    end
end

function PortentTimer:ExecuteUpdate(delta)
    self.duration = self.duration - delta
    self.activeTime = self.activeTime - delta

    local newNumber = math.round(self.duration)
    if newNumber == self.currentNumber then return end

    self.currentNumber = newNumber

    if self.duration < 0 then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText("")
        self:SetVisible(false)
        Updater:UnSubscribe(self)
        return true
    elseif self.duration < 60 then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText(self.currentNumber)
        if not(self:IsVisible()) then
            self:SetVisible(true)
            self.textLabel:SetVisible(true)
        end
    end

    if self.activeTime < 0 and self.activeLabel:IsVisible() then
        self.activeLabel:SetStretchMode(nil)
        self.activeLabel:SetStretchMode(1)
        self.activeLabel:SetText("")
        self.activeLabel:SetVisible(false)
        self:SetVisible(false)
    else
        self.activeLabel:SetStretchMode(nil)
        self.activeLabel:SetStretchMode(1)
        self.activeLabel:SetText(math.round(self.activeTime))
    end
end

function PortentTimer:SetCallbacks()
    self.callback = AddCallback(self.effectList, "EffectAdded", 
    function(sender, args)
        local effect = sender:Get(args.Index) 

        if sender:Get(args.Index):GetName() == self.name then --Threshold Morale Bubble
            self.duration = 600
            self.activeTime = effect:GetDuration()
            self:SetVisible(true)
            self.activeLabel:SetVisible(true)
            self.textLabel:SetVisible(true)
            Updater:Subscribe(self)
        end
    end)
end

function PortentTimer:RemoveCallbacks()
    RemoveCallback(self.effectList, "EffectAdded", self.callback)
end

function PortentTimer:Close()
    self:RemoveCallbacks()
    Settings["ItemPositions"][self.name].X, Settings["ItemPositions"][self.name].Y = self:GetPosition()
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

ItemToolHandler = class(Turbine.UI.Control)
function ItemToolHandler:Constructor()
    Turbine.UI.Control.Constructor(self)
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.equipment = self.player:GetEquipment()
    self.backpack = self.player:GetBackpack();

    self.tools = {}
    self.portentTools = {}

    self.threshold = false



    for i = 1, self.equipment:GetSize(), 1 do
        local item = self.equipment:GetItem(i)
        if item ~= nil then  
            --ChatOutput(item:GetName()) 
            local itemName = item:GetName()     
            if string.find(itemName, "Threshold") or string.find(itemName, "Emblem") then
                self.threshold = true
                break
            end
        end	          
    end

    if self.threshold then self.tools["Bubble"] = ThresholdBubbleTimer() end

    self.portent = {
        ["Extremely Subtle Portent of Strength"] = 1,
        ["Subtle Portent of Strength"] = 1,
        ["Portent of Strength"] = 1,
        ["Obvious Portent of Strength"] = 1,

        ["Extremely Subtle Portent of Vitality"] = 2,
        ["Subtle Portent of Vitality"] = 2,
        ["Portent of Vitality"] = 2,
        ["Obvious Portent of Vitality"] = 2,

        ["Extremely Subtle Portent of Deftness"] = 3,
        ["Subtle Portent of Deftness"] = 3,
        ["Portent of Deftness"] = 3,
        ["Obvious Portent of Deftness"] = 3,
    }

    local backpackSize = self.backpack:GetSize();

	-- Sum itemcategories
	self.ItemCounts = {}
	for i = 1, backpackSize, 1 do
		if self.backpack:GetItem(i) then
            local name = self.backpack:GetItem(i):GetName() --:GetItemInfo()

            if self.portent[name] then
                self.portentTools[name] = true
            end
		end
	end	

    for key, value in pairs(self.portentTools) do
        if Settings["ItemPositions"][key] == nil then
            Settings["ItemPositions"][key] = {}
            Settings["ItemPositions"][key].X = 500 + 50 * self.portent[key]
            Settings["ItemPositions"][key].Y = 500 + 50 * self.portent[key]
        end


        self.tools[key] = PortentTimer(key, self.portent[key])
    end
end

function ItemToolHandler:Close()
    for key, value in pairs(self.tools) do
        value:Close()
    end
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

VitalBar = class( Turbine.UI.Control );
function VitalBar:Constructor(width, height, showText, textAlignment)
    Turbine.UI.Control.Constructor( self )
    
    self:SetSize(width, height)
    self:SetZOrder(100)
    self:SetMouseVisible(false)

    --self.MaxValue = 100
    --self.CurrentValue = 0
    self.TempValue = 0
    self.MaxTempValue = 0
    self.DreadValue = 0

    self.NumberMethod = 1
    self.PercentageShown = false
    self.OnlyShowCurrent = true
    self.showText = showText

    self.CurrentImmediate = 0
    self.CurrentValue = Turbine.Animation.LerpValue()
	self.MaxValue = 0--Turbine.Animation.LerpValue()
    self.baseMax = 0--Turbine.Animation.LerpValue()
    
    Background = "PrimePlugins/Vitals/Images/FittedSmooth.tga"

    --self:SetBackColor( Turbine.UI.Color( 1, 1, 0, 0 ) )
    
    -- The background bar that contains all other bars
    self.TotalBar = Turbine.UI.Control()
    self.TotalBar:SetParent(self)
    --self.TotalBar:SetSize(256, 32)
    --self.TotalBar:SetStretchMode(1)
    --self.TotalBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay )
    --self.TotalBar:SetBackground(Background)
    self.TotalBar:SetSize(width, height)
    self.TotalBar:SetMouseVisible(false)

    -- The current value of the display
    self.CurrentBar = Turbine.UI.Control()
    --self.CurrentBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay )
    self.CurrentBar:SetParent(self)
    self.CurrentBar:SetSize(0, height)
    self.CurrentBar:SetMouseVisible(false)

    -- Indicating morale loss/gain
    self.MoveBar = Turbine.UI.Control()
    --self.MoveBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.MoveBar:SetParent(self)
    self.MoveBar:SetSize(0, 0)
    self.MoveBar:SetMouseVisible(false)

    -- Bar to show temporary effects (bubbles)
    self.TemporaryBar = Turbine.UI.Control()
    --self.TemporaryBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.TemporaryBar:SetParent(self)
    self.TemporaryBar:SetSize(0, height)
    self.TemporaryBar:SetMouseVisible(false)

    -- Bar to show temporary effects negative (dread)
    self.DreadBar = Turbine.UI.Control()
    --self.DreadBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
    self.DreadBar:SetParent(self)
    self.DreadBar:SetSize(0, 0)
    self.DreadBar:SetMouseVisible(false)

	-- The animation classes for smoothly moving the bars.

    -- The display text for the vitals bar.
    -- [[
    if self.showText then
        self.text = Turbine.UI.Label()
        self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1, 1 ) )
        self.text:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
        self.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
        self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold19 )
        if textAlignment == Turbine.UI.ContentAlignment.MiddleRight then
            self.text:SetPosition(-10, 0)
        end
        self.text:SetTextAlignment( textAlignment )
        self.text:SetZOrder( 100 )
        self.text:SetParent( self )
        self.text:SetSize(width, height)
        self.text:SetMouseVisible(false)
    end
    --]]

	--self.horizontalLayout = Turbine.UI.HorizontalLayout.LeftToRight;
	self.showPercentage = false;

	self.lastUpdate = 0;
end

function VitalBar:SetColours(BackColour, BarColour, TempColour, DreadColour)
    self.TotalBar:SetBackColor(BackColour)
    self.CurrentBar:SetBackColor(BarColour)
    self.TemporaryBar:SetBackColor(TempColour)
    self.DreadBar:SetBackColor(DreadColour)
end

function VitalBar:SetMaxValue(value)
    self.MaxValue = value
    self.CurrentValue:SetRate( self.MaxValue / self:GetWidth() * 200 );
end

function VitalBar:SetCurrentValue(value)
    self.CurrentValue:SetValue(value)

    if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true );
	end
end

function VitalBar:SetCurrentValueImmediate(value)
    self.CurrentValue:SetValueImmediate(value)

    --if ( self.CurrentValue:NeedsUpdate() ) then
		self:SetWantsUpdates( true );
	--end
end

function VitalBar:SetTempValue(value)
    self.TempValue = value
    self:AdjustBars()
end

function VitalBar:SetMaxTempValue(value)
    self.MaxTempValue = value
    --self:AdjustBars()
end

function VitalBar:SetDreadValue(value)
    self.DreadValue = value
end

function VitalBar:Update( args )
	local delta = 0;
	local currentTime = Turbine.Engine.GetGameTime();

	if ( self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate;
	end

	self.lastUpdate = currentTime;

	self.CurrentValue:Update( delta );
	--self.MaxValue:Update( delta );
	--self.baseMax:Update( delta );

        --[[
	local current = math.floor( self.CurrentValue:GetValue() + 0.5 ) 
	local max = math.floor( self.MaxValue:GetValue() + 0.5 ) 
    local baseMax = math.floor( self.baseMax:GetValue() + 0.5 ) 
    
	if ( self.showPercentage ) then
		local percentage = math.floor( ( current / max * 100 ) + 0.5 );
		self.text:SetText( percentage .. "%" );
	else
		self.text:SetText( current .. "/" .. max );
    end
    

	self:PerformLayout();

    --]]
	if not(self.CurrentValue:NeedsUpdate()) then
		self:SetWantsUpdates( false );
		self.lastUpdate = 0;
    end
    
    self:AdjustBars()
end

function VitalBar:AdjustBars()

    local value = self.CurrentValue:GetValue()
    local totalWidth, currentHeight = self.TotalBar:GetSize()
    local totalHealthValue = self.MaxValue + self.TempValue
    local currentWidth = value / totalHealthValue * totalWidth

    self.CurrentBar:SetWidth(math.ceil(currentWidth))
    self.CurrentBar:SetLeft(totalWidth / 2 - currentWidth / 2)

    --self.CurrentBar:SetBackColor(Turbine.UI.Color(0.4 + 0.6 - 0.6 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.5, 0.1))
    --self.TotalBar:SetBackColor(Turbine.UI.Color(0.4 + 0.6 - 0.6 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.7 - 0.3 * self.CurrentValue:GetValue() / (self.MaxValue:GetValue() + self.TempValue) , 0.1))

    --if self.TempValue > 0 then 
        --self.TemporaryBar:SetWidth(math.ceil(self.TempValue / totalHealthValue * totalWidth))
        --self.TemporaryBar:SetPosition(currentWidth, 0)
    --end

    if self.showText then
        local tempString = ""

        if self.TempValue > 0 then
            tempString = " (+" ..  self:FormatNumber(math.ceil(self.TempValue)) .. ") " 
        end

        self.text:SetText(  self:GetHealthString(value) .. tempString .. self:FormatPercentage(value))
    end
end

function VitalBar:SetTextVisible(value)
    if self.text then self.text:SetVisible(value) end
end

function VitalBar:FormatNumber(number) 
    if self.NumberMethod == 1 then
        return number
    elseif self.NumberMethod == 2 then
        return FormatBigNumber(number)
    end
end

function VitalBar:GetHealthString(value)
    if self.OnlyShowCurrent then
        return self:FormatNumber(math.floor( value+ 0.5 ))
    else
        return self:FormatNumber(math.floor( value + 0.5 ))  .. "/" .. self:FormatNumber(math.floor( self.MaxValue + 0.5 ))
    end
end

function VitalBar:FormatPercentage(value) 
    if self.PercentageShown then
        return " - " .. math.floor(value / self.MaxValue * 100) .. "%"
    else
        return ""
    end
end


-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

BeorningTools = class(Turbine.UI.Window)
function BeorningTools:Constructor(data)
    Turbine.UI.Window.Constructor(self)
    self.width = 500
    self.height = 150
    self:SetPosition(Settings.ClassToolsX, Settings.ClassToolsY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.data = data

    -- 0x411172A2 kisses
    -- 0x4115B59E broken armour
    -- 0x4115B58E crit roar
    -- 0x4115B58E knockdown
    -- 0x4115B586 blue buff
    -- 0x4115B59D blue recup
    -- 0x4115B5C1 blue green recup
    -- 0x4115B5BC red bear form icon
    -- 0x4115B5BA bash bleed + 
    -- 0x4115B59B free heal roar
    -- 0x4115B5AF slash bleed
    -- 0x41139EFF Blood rage
    -- 0x4113A06D Yellow break ranks
    -- 0x4115B59F Blue armour crush

    self.moveBox = MoveBox(self, self.width, self.height, "Beorning Tools")

    self.buffSkillBar = DynamicSkillBar(self, 0, 0, self.width, 32, 32, 2, true)
    self.normalSkillBar = DynamicSkillBar(self, 0, 52, self.width, 64, 32, 4, false)
    self.specialSkillBar = DynamicSkillBar(self, 0, 84, self.width, 64, 32, 4, false)
    self.markBar = DynamicSkillBar(self, self.width / 2 - 16 - 32, 116, 96, 64, 32, 4, false)

    self:LoadData()

    self.name = self.player:GetName()

    self.noSkills = Settings.ClassToolsNoSkills
    --self.noSkills = true

    self.playerCallbacks = {}
    self.effectCallbacks = {}
    self.attrCallbacks = nil

    self.skillCallbacks = {}
    self.skillsLUT = {}

    self.skillCount = 0 
    self.specialSkillCount = 0

    self.formSlots = {}
    
    self.skillSlots = {}
    self.specialSkillSlots = {}

    self.currentForm = "Man-form"
    self.ferocious = Settings.ClassToolsBeorningFerocious
    self.slashBleed = Settings.ClassToolsBeorningSlash

    self.skills = {
        ["Encouraging Roar"] = {1, "0x700412EE", 1}, -- 
        ["Rejuvenating Bellow"] = {2, "0x70041F62", 1}, -- 
        ["Recuperate"] = {3, "0x7004128D", 1},
        ["Relentless Maul"] = {4, "0x700403B9", 1}, -- 
        ["Rending Blow"] = {5, "0x7004128B", 1},
        ["Grisly Cry"] = {6, "0x700403B7", 1},
        ["Takedown"] = {7, "0x700412ED", 1},
        ["Thrash - Tier 1"] = {8, "0x70041E78", 1},

        ["Expose (Man)"] = {1, "0x70041258", 1},
        ["Expose (Bear)"] = {1, "0x70041258", 1},
        ["Bash"] = {2, "0x70041255", 1},
        ["Bee Swarm"] = {9, "0x700403BB", 1},
        ["Slash"] = {20, "0x7004038F", 1},
        ["Slam"] = {21, "0x70040391", 1},
        ["Biting Edge"] = {22, "0x70040390", 1},
        ["Ferocious Roar"] = {23, "0x7004039C", 1},
        ["Hearten"] = {24, "0x7004039B", 1},
        ["Nature's Mend"] = {25, "0x700412EA", 1},

        ["Vigilant Roar"] = {1, "0x700403B6", 2},
        ["Thunderous Roar"] = {2, "0x70042DD1", 2},
        ["Piercing Roar"] = {5, "0x70041253", 2},
        ["Sacrifice"] = {10, "0x700403B8", 2},
        ["Shake Free"] = {11, "0x7004039D", 2},
        ["Cleanse"] = {12, "0x7004039E", 2},
        ["Rush"] = {13, "0x7004039A", 2},
        ["Nature's Bond"] = {14, "0x70041F1B", 2},
        ["Vicious Claws"] = {20, "0x700403BA", 2},
        ["Nature's Vengeance"] = {21, "0x7004039F", 2},
        --["Bear Up"] = {22, "0x70042DB4", 2},
        ["Overbearing"] = {22, "0x70042DD0", 2},
        --["Overbearing"] = {, "0x70042DD0", 2},
    }

    if self.data == nil then
        self.data = {}
        for key, value in pairs(self.skills) do
            self.data[key] = {true, value[1], value[3]}
        end
    else
        for key, value in pairs(self.data) do
            --ChatOutput(value[1])
            if value[1] == false then
                self.skills[key] = nil
            else
                self.skills[key] = {value[2], self.skills[key][2], value[3]}
            end
        end
    end

    self.dynamicSkillTable = {
        ["Encouraging Roar"] = {15, 1091940904, 2},
        ["Rending Blow"] = {10, 0x4115B59F, 2},
        ["Bee Swarm"] = {12, 0x4115B220, 10}
        --1091940904
    }

        self.parseSkills = {
        ["Mark of Grimbeorn"] = true,
        ["Encouraging Roar"] = true,
        ["Slash"] = true,
    }

    self.dynamicEffectTable = {
        -- Yellow + Base
        ["Recuperate"] = {1091940911, 3},
        ["Aiding Strike - Tier 1"] = {1091945028, 1},
        ["Aiding Strike - Tier 2"] = {1091945017, 1},
        ["Aiding Strike - Tier 3"] = {1091945029, 1},
        ["Assertive Roar"] = {1091941769, 10},
        ["Rush"] = {1091940899, 50},
        ["Vicious Rage"] = {1091941770, 5},
        ["Ferocious Roar"] = {1091940918, 30},
        ["Hardened Heart"] = {1091941799, 30},
        ["Enduring Hide"] = {1091941829, 20},
        ["Honey Cleanse"] = {1091945026, 5}, -- 2 1091945041 -- 3

        -- Blue
        ["Thickened Hide"] = {1091940987, 1},
        ["Counter"] = {1091940905, 2},
        ["Guarded - Tier 1"] = {1091945024, 3},
        ["Guarded - Tier 2"] = {1091945020, 3},
        ["Guarded - Tier 3"] = {1091945022, 3},
        ["Guarded - Tier 4"] = {1091945035, 3},
        ["Guarded - Tier 5"] = {1091945040, 3},

        -- Red
        ["Sharpened Claws"] = {1091941774, 5},
        ["Expose Weakness - Man Form"] = {1091941790, 1},
        ["Expose Weakness - Bear Form"] = {1091940901, 1},
        ["Raining Blows - Tier 1"] = {1091945038, 10},
        ["Raining Blows - Tier 2"] = {1091945036, 10},
        ["Raining Blows - Tier 3"] = {1091945019, 10},
    }
    --        ["Honey Cleanse"] = {1091945026, 5}, -- 2 1091945041 -- 3

    self.removeEffectTable = {
        ["Aiding Strike - Tier 1"] = true,
        ["Aiding Strike - Tier 2"] = true,
        ["Aiding Strike - Tier 3"] = true,
        ["Assertive Roar"] = true,  
        ["Ferocious Roar"] = true,
        ["Raining Blows - Tier 1"] = true,
        ["Raining Blows - Tier 2"] = true,
        ["Raining Blows - Tier 3"] = true,
        ["Relentless Maul"] = true,
        ["Guarded - Tier 1"] = true,
        ["Guarded - Tier 2"] = true,
        ["Guarded - Tier 3"] = true,
        ["Guarded - Tier 4"] = true,
        ["Guarded - Tier 5"] = true,
        ["Honey Cleanse"] = true,
    }

    self.healSkills = {
        ["Encouraging Roar"] = true,
        ["Rejuvenating Bellow"] = true,
        ["Recuperate"] = true,
        ["Hearten"] = true,
        ["Nature's Mend"] = true,
    }

    self.exceptionEffects = {
        ["Expose Weakness - Man Form"] = true,
        ["Expose Weakness - Bear Form"] = true,
    }

    self.mountedGarbage = {
        [1091742735] = true,
        [1091742016] = true,
        [1091787642] = true,
        [1091787641] = true,
    }

    self:Load()
end

function BeorningTools:GetData()
    return self.data
end

function BeorningTools:ChangeData(key, value)
    self.data[key] = value
end

function BeorningTools:RemoveCallbacks()
    for key, value in pairs(self.effectCallbacks) do
        RemoveCallback(self.effectList, key, value)
    end

    RemoveCallback(self.ClassAttr, "WrathChanged", self.attrCallbacks)

    --player callbacks
    for key, value in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, key, value)
    end

    for key, value in pairs(self.skillCallbacks) do
        for _, callback in pairs(value) do
            RemoveCallback(self.skillsLUT[key], "ResetTimeChanged", callback)
        end
    end

    collectgarbage()

end

function BeorningTools:SetCallbacks()

    self.effectCallbacks["EffectAdded"] = AddCallback(self.effectList, "EffectAdded", 
    function(sender, args)
        local effect = sender:Get(args.Index) 
        local effectName = effect:GetName()

        --ChatOutput(effectName .. effect:GetIcon())

        if self.formSlots[effectName] then
            self.formSlots[self.currentForm]:ToggleVisible(false)
            self.currentForm = effectName
            self.formSlots[effectName]:ToggleVisible(true)
        end

        if self.dynamicEffectTable[effectName] then 
            if effectName == "Honey Cleanse" then
                if effect:GetIcon() == 1091945026 then
                    self.buffSkillBar:ToggleLabel("Honey Cleanse", true)
                elseif effect:GetIcon() == 1091945041 then
                    self.buffSkillBar:ToggleLabel("Honey Cleanse 2", true)
                else
                    self.buffSkillBar:ToggleLabel("Honey Cleanse 3", true)
                end
            elseif self.dynamicEffectTable[effectName][1] == effect:GetIcon() and not(self.exceptionEffects[effectName]) then
                self.buffSkillBar:ToggleLabel(effectName, true, effect:GetDuration())
            elseif self.exceptionEffects[effectName] then
                if effectName == "Expose Weakness - Man Form" or effectName == "Expose Weakness - Bear Form" then
                    self.buffSkillBar:ToggleLabel(effectName, true, effect:GetDuration())
                    if effectName == "Expose Weakness - Man Form" then
                        self.buffSkillBar:ToggleLabel("Expose Weakness - Bear Form", nil)
                    else
                        self.buffSkillBar:ToggleLabel("Expose Weakness - Man Form", nil)
                    end
                end
            end
        end
    end)


    self.effectCallbacks["EffectRemoved"] = AddCallback(self.effectList, "EffectRemoved", 
    function(sender, args)

        local effect = args.Effect
        if self.removeEffectTable[effect:GetName()] then
            if effect:GetName() == "Relentless Maul" and not(self.noSkills) then
                if self.skills[effect:GetName()][3] == 1 then
                        self.normalSkillBar:SetLabelTimer(effect:GetName(), 30)
                elseif self.skills[effect:GetName()][3] == 2 then
                        self.specialSkillBar:SetLabelTimer(effect:GetName(), 30)
                end
            elseif effect:GetName() == "Honey Cleanse" then
                                if effect:GetIcon() == 1091945026 then
                    self.buffSkillBar:ToggleLabel("Honey Cleanse", nil)
                elseif effect:GetIcon() == 1091945041 then
                    self.buffSkillBar:ToggleLabel("Honey Cleanse 2", nil)
                else
                    self.buffSkillBar:ToggleLabel("Honey Cleanse 3", nil)
                end
            else
                self.buffSkillBar:ToggleLabel(effect:GetName(), false)
            end
        end

        --[[
        if self.dynamicEffectTable[effect:GetName()] and 
        self.dynamicEffectTable[effect:GetName()][1] == effect:GetIcon() and 
        not(self.exceptionEffects[effectName]) then
            self.buffSkillBar:ToggleLabel(effect:GetName(), false)
        end
        --]]
    end)

    self.attrCallbacks = AddCallback(self.ClassAttr, "WrathChanged", function(sender, args) self.wrathBar:SetCurrentValue( sender:GetWrath() ) end)

    -- skill callbacks
    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()
        --ChatOutput(name .. item:GetSkillInfo():GetIconImageID())

        self.skillCallbacks[name] = {}

        if self.skills[name] and not(string.find(name, "Maul")) and not(self.noSkills) then
            self.skillsLUT[name] = item
            if self.skills[name][3] == 1 then
                table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                    self.normalSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
                end))
            elseif self.skills[name][3] == 2 then
                table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                    self.specialSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
                end))
            end
        end

        if name == "Ferocious Roar" and self.ferocious then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                local timer = nil
                if not(self.player:IsInCombat()) then timer = 9 end
                self.buffSkillBar:ToggleLabel("Ferocious Free Heal", true, timer)
            end))
        end

        if name == "Slash" and self.slashBleed then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                if self.currentForm == "Man-form" then
                    self.buffSkillBar:ToggleLabel("Slash Bleed", true, 10)
                end
            end))
        end

        if self.dynamicSkillTable[name] and name ~= "Encouraging Roar" then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.buffSkillBar:ToggleLabel(name, true, self.dynamicSkillTable[name][1])
            end))
        end

        if self.healSkills[name] and self.ferocious then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.buffSkillBar:ToggleLabel("Ferocious Free Heal", nil)
            end))
        end

        if name == "Mark of Grimbeorn" and not(self.skills) then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.markTarget = nil
                self.markBar:SetLabelTimer(name, 5)
            end))
        end

        if name == "Mark of Beorn" and not(self.skills) then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.markBar:SetLabelTimer(name, 5)
            end))
        end
    end

    self.playerCallbacks["InCombatChanged"] = AddCallback(self.player, "InCombatChanged",
    function(sender, args)
        if self.ferocious and not(self.player:IsInCombat()) then
            self.buffSkillBar:ToggleLabel("Ferocious Free Heal", true, 9)
        end
    end)

end

function BeorningTools:SetSkillObjects()

    ChatEventHandler:SubscribeTools(self)
    ChatEventHandler:TogglePlayerCombat(true)

    if not(self.noSkills) then
        self.formSlots["Man-form"] = ClassSkillSlot(self, self.width / 2 - 16, 116, 32, 32, "0x70052366", true)
        self.formSlots["Bear-form"] = ClassSkillSlot(self, self.width / 2 - 16, 116, 32, 32, "0x700422ED", true)
        self.formSlots["Wanderlust"] = ClassSkillSlot(self, self.width / 2 - 16, 116, 32, 32, "0x70051DFF", true)
    end
    
        -- Handle initial state
        for i = 1, self.effectList:GetCount(), 1 do
            local name = self.effectList:Get(i):GetName()
    
            if self.formSlots[name] then self.formSlots[name]:ToggleVisible(true); self.currentForm = name end
        end 


    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()

        if name == "Mark of Grimbeorn" and not(self.noSkills) then 
            self.blueMark = ClassSkillSlot(self, self.width / 2 - 48, 116, 32, 32, "0x700412EF", false) 
            self.markBar:AddLabel(name, self.blueMark, 1)
        end
        if name == "Mark of Beorn" and not(self.noSkills) then 
            self.redMark = ClassSkillSlot(self, self.width / 2 + 16, 116, 32, 32, "0x700412EB", false) 
            self.markBar:AddLabel(name, self.redMark, 1)
        end


        if self.skills[name] and not(self.mountedGarbage[item:GetSkillInfo():GetIconImageID()]) and not(self.noSkills) then
            if self.skills[name][3] == 1 then
                self.skillSlots[name] = ClassSkillSlot(self.normalSkillBar, self.width / 2 - 16, 0, 32, 32, self.skills[name][2], false)
                self.normalSkillBar:AddLabel(name, self.skillSlots[name], self.skills[name][1])
                self.skillCount = self.skillCount + 1
            elseif self.skills[name][3] == 2 then
                self.specialSkillSlots[name] = ClassSkillSlot(self.specialSkillBar, self.width / 2 - 16, 0, 32, 32, self.skills[name][2], false)
                self.specialSkillBar:AddLabel(name, self.specialSkillSlots[name], self.skills[name][1])
                self.specialSkillCount = self.specialSkillCount + 1
            end
        end

        if name == "Ferocious Roar" and 1091940918 == item:GetSkillInfo():GetIconImageID() then
            self.buffSkillBar:AddLabel("Ferocious Free Heal", ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, 0x4115B59B, false, false, nil, 1, 1, true, false, true), 2)
        end
    end

    --self.buffSkillBar:AddLabel("Honey Cleanse 1", ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, 1091945026, false, false, nil, 1, 1, true, false, true), 2)
    self.buffSkillBar:AddLabel("Honey Cleanse 2", ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, 1091945041, false, false, nil, 1, 1, true, false, true), 2)
    self.buffSkillBar:AddLabel("Honey Cleanse 3", ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, 1091945033, false, false, nil, 1, 1, true, false, true), 2)

    local padding = (self.width - self.skillCount * 32 ) / 2

    local positionCounter = 0
    for key, value in spairs(self.skillSlots, function(t,a,b) return self.skills[b][1] > self.skills[a][1] end) do
        value:SetPosition(padding + positionCounter * 32, 0)
        positionCounter = positionCounter + 1
    end

    local specialPadding = (self.width - self.specialSkillCount * 32 ) / 2

    positionCounter = 0
    for key, value in spairs(self.specialSkillSlots, function(t,a,b) return self.skills[b][1] > self.skills[a][1] end) do
        value:SetPosition(specialPadding + positionCounter * 32, 0)
        positionCounter = positionCounter + 1
    end

    for key, value in pairs(self.dynamicSkillTable) do
        self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[2], false, false, nil, 1, 1, true, false, true), value[3])
    end

    for key, value in pairs(self.dynamicEffectTable) do
        self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, true), value[2])
    end

    if self.slashBleed then
        self.buffSkillBar:AddLabel("Slash Bleed", ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, 0x4115B5AF, false, false, nil, 1, 1, true, false, true), 2)
    end

    local barWidth = (math.max(self.skillCount, self.specialSkillCount) * 32 )
    if barWidth == 0 then barWidth = 500 end

    -- Wrath bar
    self.wrathBar = VitalBar(barWidth - 1, 20, true, Turbine.UI.ContentAlignment.MiddleCenter)
    self.wrathBar:SetParent(self)
    self.wrathBar:SetPosition(1 + (self.width - barWidth) / 2, 32)
    self.wrathBar:SetColours(nil, Turbine.UI.Color(0.6, 0.5, 0, 0), nil, nil)
    self.wrathBar:SetMaxValue(100)
    self.wrathBar:SetCurrentValue(self.ClassAttr:GetWrath())
end

function BeorningTools:ToggleMove()
    self.moveBox:ToggleMove()
end

function BeorningTools:GetOptions(parent, x, y)
    local container = Turbine.UI.Control()
    container:SetParent(parent)
    container:SetPosition(x, y)
    container:SetSize(530 + 4, 100 + 4)
    container:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(container)
    SingleBackground:SetPosition(2, 2)
    SingleBackground:SetSize(530, 100)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox = Turbine.UI.Lotro.CheckBox();
    EffectBox:SetParent(SingleBackground)
    EffectBox:SetPosition(10, 10);
    EffectBox:SetSize(200,20);
    EffectBox:SetChecked(Settings.ClassToolsBeorningSlash)
    EffectBox:SetText("Bleed on slash timer");
    EffectBox:SetVisible(true);

    EffectBox.CheckedChanged = function()
        Settings.ClassToolsBeorningSlash = EffectBox:IsChecked()
    end

    local EffectBox1 = Turbine.UI.Lotro.CheckBox();
    EffectBox1:SetParent(SingleBackground)
    EffectBox1:SetPosition(10, 30);
    EffectBox1:SetSize(200,20);
    EffectBox1:SetChecked(Settings.ClassToolsBeorningFerocious)
    EffectBox1:SetText("Free heal on ferocious");
    EffectBox1:SetVisible(true);

    EffectBox1.CheckedChanged = function()
        Settings.ClassToolsBeorningFerocious = EffectBox1:IsChecked()
    end

    local EffectBox2 = Turbine.UI.Lotro.CheckBox();
    EffectBox2:SetParent(SingleBackground)
    EffectBox2:SetPosition(10, 50);
    EffectBox2:SetSize(200,20);
    EffectBox2:SetChecked(Settings.ClassToolsNoSkills)
    EffectBox2:SetText("Disable skill bars");
    EffectBox2:SetVisible(true);

    EffectBox2.CheckedChanged = function()
        Settings.ClassToolsNoSkills = EffectBox2:IsChecked()
    end

    
end

function BeorningTools:RemoveSkillObjects()
    self.buffSkillBar:Unload()
    self.normalSkillBar:Unload()
    self.specialSkillBar:Unload()
    self.wrathBar:SetParent(nil)

    ChatEventHandler:SubscribeTools(nil)
    ChatEventHandler:TogglePlayerCombat(nil)

    for _, value in pairs(self.formSlots) do
        value:Unload()
    end

    self.formSlots = {}
    self.skillSlots = {}
    self.specialSkillSlots = {}

    self.skillCount = 0
    self.specialSkillCount = 0

    collectgarbage()
end

function BeorningTools:ParseUpdate(message)
    local source, _, skillName, target = string.match(string.gsub(string.gsub(message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"),"^(.*) applied a (.*) with (.*) on (.*)%.$")

    if source ~= self.name then return end
    if self.parseSkills[skillName] then
        if skillName == "Mark of Grimbeorn" then
            self.markTarget = target
        end

        if  skillName == "Encouraging Roar" and self.markTarget == target then
            self.buffSkillBar:ToggleLabel("Encouraging Roar", true, 15)
        end

        if skillName == "Slash" and target ~= self.name then
            self.buffSkillBar:ToggleLabel("Slash Bleed", true, 10)
        end
    end    
end

function BeorningTools:LoadData()
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.effectList = self.player:GetEffects()
    self.ClassAttr = self.player:GetClassAttributes()
    self.trainedSkills = self.player:GetTrainedSkills()
end

function BeorningTools:Load()
    self:SetSkillObjects()
    self:SetCallbacks()
end

function BeorningTools:Unload()
    self:RemoveCallbacks()
    self:RemoveSkillObjects()
end

function BeorningTools:Reload()
    self:Unload()
    self:LoadData()
    self:Load()
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

StackingClassTimerLabel = class(Turbine.UI.Window)
function StackingClassTimerLabel:Constructor(parent, x, y, base, normal, baseIcon, visible, reverse, duration, normalOpacity, usageOpacity, hide, shade, text, stack)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = normal
    self.reverse = reverse
    self.normalOpacity = normalOpacity
    self.usageOpacity = usageOpacity
    self.hide = hide
    self.shade = shade
    self.text = text

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.normal, self.normal)
    self:SetVisible(visible)
    self:SetOpacity(normalOpacity)

    self.currentNumber = -1
    self.currentPercentage = 0

    self.baseImageID = 0x41007E35;

    self.IconLabel = Turbine.UI.Label()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetSize(self.base, self.base)
    self.IconLabel:SetStretchMode(1)
    self.IconLabel:SetBackground(baseIcon)
    self.IconLabel:SetSize(self.normal, self.normal)

    self.stackLabel = Turbine.UI.Label()
    self.stackLabel:SetParent(self)
    self.stackLabel:SetSize(self.base - 3, self.base)
    self.stackLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopRight)
    --self.stackLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.stackLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.stackLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.stackLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.stackLabel:SetMouseVisible(false)
    self.stackLabel:SetStretchMode(1)
    self.stackLabel:SetText(stack)

    if self.shade then
        self.elapsedOverlay = Turbine.UI.Control();
        self.elapsedOverlay:SetStretchMode( 1 );
        self.elapsedOverlay:SetMouseVisible( false );
        --self.elapsedOverlay:SetZOrder( 99 );
        self.elapsedOverlay:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
        self.elapsedOverlay:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
        self.elapsedOverlay:SetParent( self );
        self.elapsedOverlay:SetPosition(-1, -1)
        self.elapsedOverlay:SetSize(self.normal + 2, self.normal + 2)
    end
    
    if self.text then
        self.textLabel = Turbine.UI.Label()
        self.textLabel:SetParent(self)
        self.textLabel:SetSize(self.normal, self.normal)
        self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
        self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
        self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        self.textLabel:SetMouseVisible(false)
    end

    -- Add timer overlay

    self.startTime = Turbine.Engine.GetGameTime()
end

function StackingClassTimerLabel:SetTimer(timer, maxTimer)
    if maxTimer then
        self.overlaydDuration = maxTimer
        self.startTime = Turbine.Engine.GetGameTime() - (maxTimer - timer)
    else
        self.overlaydDuration = timer
        self.startTime = Turbine.Engine.GetGameTime()
    end
    self.duration = timer
    self:SetOpacity(self.usageOpacity)

    --Updater:Subscribe(self)
end

function StackingClassTimerLabel:ExecuteUpdate(delta)

    self.duration = self.duration - delta
    if self.duration < 0 then 
        --Updater:UnSubscribe(self)
        self:SetOpacity(self.normalOpacity)
        if self.hide then self:SetVisible(false) end 

        if self.text then
            self.textLabel:SetText("")
        end
        return true
    end

    if self.shade then

        local percentComplete = math.floor(60 * (Turbine.Engine.GetGameTime() - self.startTime) / self.overlaydDuration)
        if self.reverse then
            percentComplete = 60 - percentComplete
        end

        if self.currentPercentage ~= percentComplete then 

            self.currentPercentage = percentComplete

            local imageId = self.baseImageID + self.currentPercentage            

            self.elapsedOverlay:SetStretchMode( 3 );
            self.elapsedOverlay:SetSize( 32, 32 );
            self.elapsedOverlay:SetBackground( imageId );
            self.elapsedOverlay:SetStretchMode( 1 );
            self.elapsedOverlay:SetSize( self.normal + 2, self.normal + 2);
        end
    end

    local newNumber = math.round(self.duration)
    if newNumber == self.currentNumber then return end

    self.currentNumber = newNumber

    if self.text then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText(self.currentNumber)
    end
end

function StackingClassTimerLabel:ToggleVisible(value)
    self:SetVisible(value)
    self.IconLabel:SetVisible(value)
end

function StackingClassTimerLabel:Unload()
    self.IconLabel:SetParent(nil)
    if self.textLabel then self.textLabel:SetParent(nil) end
    if self.elapsedOverlay then self.elapsedOverlay:SetParent(nil) end
    self:SetParent(nil)
    self = nil
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

ResourceBar = class( Turbine.UI.Control );
function ResourceBar:Constructor(parent)
    Turbine.UI.Control.Constructor( self )

    self.width = 320
    self.height = 20

    self:SetSize(self.width, self.height)
    self:SetZOrder(100)
    self:SetMouseVisible(false)
    --self:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))
    self:SetParent(parent)
    self:SetPosition(0, y)

    self.BarDictionary = {}

    self.colourTable = {
        [1] = Turbine.UI.Color(0.8, 0, 0.4, 0),
        [2] = Turbine.UI.Color(0.8, 0, 0.4, 0),
        [3] = Turbine.UI.Color(0.8, 0, 0.4, 0),
        [4] = Turbine.UI.Color(0.8, 0.4, 0.4, 0),
        [5] = Turbine.UI.Color(0.8, 0.4, 0.4, 0),
        [6] = Turbine.UI.Color(0.8, 0.4, 0.4, 0),
        [7] = Turbine.UI.Color(0.8, 0.4, 0, 0),
        [8] = Turbine.UI.Color(0.8, 0.4, 0, 0),
        [9] = Turbine.UI.Color(0.8, 0.4, 0, 0),
    }


    self.colourTable2 = {
        [1] = Turbine.UI.Color(0.8, 0, 0.8, 0),
        [2] = Turbine.UI.Color(0.8, 0, 0.8, 0),
        [3] = Turbine.UI.Color(0.8, 0, 0.8, 0),
        [4] = Turbine.UI.Color(0.8, 0.8, 0.8, 0),
        [5] = Turbine.UI.Color(0.8, 0.8, 0.8, 0),
        [6] = Turbine.UI.Color(0.8, 0.8, 0.8, 0),
        [7] = Turbine.UI.Color(0.8, 0.8, 0, 0),
        [8] = Turbine.UI.Color(0.8, 0.8, 0, 0),
        [9] = Turbine.UI.Color(0.8, 0.8, 0, 0),
    }

    self.boxes = 9

    for i = 1, self.boxes, 1 do
        self.BarDictionary[i] = ResourceBox(self, 3 + (i - 1) * 35 , 30, 20, self.colourTable[i], self.colourTable2[i])
    end  

    self.textBox = Turbine.UI.Label()
    self.textBox:SetParent(self)
    self.textBox:SetSize(20, 20)
    self.textBox:SetPosition((self.width /2 ) - 10 - 3, 0)
    self.textBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.textBox:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
    self.textBox:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.textBox:SetFont(Turbine.UI.Lotro.Font.TrajanProBold22)
    self.textBox:SetText("0")
    --self.textBox:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.textBox:SetMouseVisible(false)
end

function ResourceBar:ChangeResource(NewNumber)
    --Turbine.UI.Color(1,0.250,0.250)
    self.textBox:SetText(NewNumber)
    for i = 1, self.boxes, 1 do
        if i <= NewNumber then
            self.BarDictionary[i]:SetVisible(true)
        else
            self.BarDictionary[i]:SetVisible(false)
        end
    end  
end

ResourceBox = class( Turbine.UI.Control );
function ResourceBox:Constructor(parent, x, width, height, colour, colour2)

    Turbine.UI.Control.Constructor( self )
    self:SetParent(parent)
    self:SetBackColor(colour2)
    --self:SetBackground("PrimePlugins/Vitals/Images/FittedSmooth.tga")
    self:SetPosition(x, 0)
    self:SetSize(width, height)
    self:SetMouseVisible(false)

    self.InnerBarBackground = Turbine.UI.Control()
    self.InnerBarBackground:SetParent(self)
    self.InnerBarBackground:SetBackColor(Turbine.UI.Color(0.250,0.250,0.250))
    self.InnerBarBackground:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.InnerBarBackground:SetPosition(1, 1)
    self.InnerBarBackground:SetSize(width, height - 1)
    self.InnerBarBackground:SetMouseVisible(false)
    self.InnerBarBackground:SetBackColor(colour)

    self.InnerBar = Turbine.UI.Control()
    self.InnerBar:SetParent(self)
    --self.InnerBar:SetBackColor(Turbine.UI.Color(1,0.250,0.250))
    self.InnerBar:SetPosition(1, 1)
    self.InnerBar:SetSize(width - 2, height - 2)
    self.InnerBar:SetMouseVisible(false)

end

function ResourceBox:TurnOn(Colour)
    self.InnerBar:SetBackColor(Colour)
end

function ResourceBox:TurnOff()
    self.InnerBar:SetBackColor()
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

HunterTools = class(Turbine.UI.Window)
function HunterTools:Constructor(data)
    Turbine.UI.Window.Constructor(self)
    self.width = 500
    self.height = 150
    self:SetPosition(Settings.ClassToolsX, Settings.ClassToolsY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.data = data

    self.moveBox = MoveBox(self, self.width, self.height, "Hunter Tools")

    self.buffSkillBar = DynamicSkillBar(self, 0, 0, self.width, 32, 32, 2, true)
    self.normalSkillBar = DynamicSkillBar(self, 0, 57, self.width, 64, 32, 4, false)
    self.specialSkillBar = DynamicSkillBar(self, 0, 89, self.width, 64, 32, 4, false)
    self.stanceSkillBar = DynamicSkillBar(self, self.width / 2 - 16 - 32, 121, 96, 64, 32, 4, false)

    self:LoadData()

    self.noSkills = Settings.ClassToolsNoSkills
    --self.noSkills = true

    self.playerCallbacks = {}
    self.effectCallbacks = {}
    self.attrCallbacks = {}

    self.skillCallbacks = {}
    self.skillsLUT = {}

    self.skillCount = 0 
    self.specialSkillCount = 0
    self.stance = 1

    self.formSlots = {}
    
    self.skillSlots = {}
    self.specialSkillSlots = {}

    self.currentForm = "Man-form"
    self.ferocious = false
    self.slashBleed = true

    self.skills = {
        ["Barbed Arrow"] = {1, "0x70003F33", 1},
        ["Improved Quick Shot"] = {2, "0x70029856", 1},
        ["Improved Swift Bow"] = {3, "0x700153E2", 1},
        ["Improved Penetrating Shot"] = {4, "0x7002984F", 1},
        ["Blood Arrow"] = {5, "0x70021D0D", 1},
        ["Exsanguinate"] = {6, "0x700364A9", 1},
        ["Barrage"] = {7, "0x7003646E", 1},
        ["Upshot"] = {8, "0x70035F62", 1},
        ["Lingering Wound"] = {9, "0x70035CC1", 1},
        ["Heart Seeker"] = {10, "0x7000A2D3", 1},
        ["Explosive Arrow"] = {11, "0x70033AEA", 1},
        ["Split Shot"] = {12, "0x700292DC", 1},
        ["Rain of Arrows"] = {13, "0x70003F36", 1},
        ["Rain of Thorns"] = {14, "0x700010F4", 1},
        ["Improved Merciful Shot"] = {15, "0x700153E5", 1},
        ["Blindside"] = {16, "0x70003F3B", 1},

        ["Piercing Trap"] = {18, "0x7000A6B1", 1},
        ["The One Trap"] = {19, "0x70035F61", 1},
        ["Decoy"] = {20, "0x70035CA7", 1},
        ["Tripwire"] = {21, "0x70037DC8", 1},



        ["Improved Focus"] = {1, "0x70029854", 2},
        ["Camouflage"] = {2, "0x70003F48", 2},
        ["Burn Hot"] = {3, "0x7000F835", 2},
        ["Intent Concentration"] = {4, "0x700030DE", 2},
        ["Rapid Fire"] = {5, "0x70036424", 2},
        ["Low Cut"] = {6, "0x70003F39", 2},
        ["Improved Dazing Blow"] = {7, "0x70021D18", 2},
        ["Scourging Blow"] = {8, "0x70003F3A", 2},
        ["Bard's Arrow"] = {9, "0x700010D3", 2},
        ["Distracting Shot"] = {10, "0x7000F9AB", 2},
        ["Purge Poison"] = {11, "0x70003F3E", 2},
        ["Cry of the Hunter"] = {12, "0x7003200C", 2},
        ["Press Onward"] = {13, "0x70010004", 2},
        ["Find the Path"] = {14, "0x70003F3D", 2},


        --["Desperate Flight"] = {1, "0x70003F40", 1},

        --["Pinning Shot"] = {1, "0x70036497", 1},
        --["Strength of the Earth"] = {1, "0x7000A2D4", 1},
        --["Beneath Notice"] = {1, "0x70020DF8", 1},


    }

    self.skillNameTimers = {
        ["Improved Penetrating Shot"] = true,
        ["Imp. Penetrating Shot: Burn Through"] = true,
        ["Imp. Penetrating Shot: Pierce the Darkness"] = true
    }

    if self.data == nil then
        self.data = {}
        for key, value in pairs(self.skills) do
            self.data[key] = {true, value[1], value[3]}
        end
    else
        for key, value in pairs(self.data) do
            --ChatOutput(value[1])
            if value[1] == false then
                self.skills[key] = nil
            else
                self.skills[key] = {value[2], self.skills[key][2], value[3]}
            end
        end
    end

    self.dynamicSkillTable = {
        --["Encouraging Roar"] = {15, 1091940904, 2},
        --1091940904
        ["Improved Penetrating Shot"] = {10, 1090553933, 4},
        ["Barbed Arrow"] = {12, 1090553904, 1},
        ["Exsanguinate"] = {20, 1091804879, 2},
        ["Lingering Wound"] = {10, 1091804872, 3},

    }

    self.dynamicEffectTable = {
        -- Yellow + Base
        --["Recuperate"] = {1091940911, 3},
        ["Improved Focus"] = {1090553915, 10},
        ["Fast Draw - Tier 1"] = {1090532013, 16},
        ["Fast Draw - Tier 2"] = {1090532013, 16},
        ["Fast Draw - Tier 3"] = {1090532013, 16},
        ["Swift and True"] = {1090541188, 17},
        ["Needful Haste"] = {1090541202, 18},
        ["Burn Hot"] = {1091456474, 20},
        ["Strength Stance Bonus"] = {1090553959, 14},
        ["Precision Stance Bonus"] = {1090553958, 14},
        ["Endurance Stance Bonus"] = {1090553960, 14},
        ["Rapid Fire"] = {1091804881, 19},
        ["Volley"] = {1090598919, 15},
        ["Strong Draw"] = {1091798514, 15},
        ["Improved Fleetness"] = {1091463726, 13},

    }

    self.specialEffectTable = {
        ["Fast Draw - Tier 1"] = {1090532013, 16, 1},
        ["Fast Draw - Tier 2"] = {1090532013, 16, 2},
        ["Fast Draw - Tier 3"] = {1090532013, 16, 3},
    }

    self.removeEffectTable = {
        --["Aiding Strike - Tier 1"] = true,
        ["Fast Draw - Tier 1"] = true,
        ["Fast Draw - Tier 2"] = true,
        ["Fast Draw - Tier 3"] = true,
        ["Volley"] = true,
        ["Strong Draw"] = true,
    }

    self.stanceSkills = {
        ["Stance: Precision"] = 1,
        ["Stance: Strength"] = 2,
        ["Stance: Endurance"] = 3,
    }
    self:Load()
end

function HunterTools:SetSkillObjects()

    ChatEventHandler:SubscribeTools(self)
    ChatEventHandler:TogglePlayerCombat(true)
    
    if Roles:GetLine() == 3 then
        self.skills["Set Trap"] = {17, "0x700030BB", 1}
    else
        self.skills["Set Trap"] = nil
    end

    if not(self.noSkills) then
        self.formSlots[1] = ClassSkillSlot(self, self.width / 2 - 16 - 32, 121, 32, 32, "0x70003F4D", false) -- "Stance: Precision"
        self.formSlots[2] = ClassSkillSlot(self, self.width / 2 - 16, 121, 32, 32, "0x70003F4E", false) -- "Stance: Strength"
        self.formSlots[3] = ClassSkillSlot(self, self.width / 2 - 16 + 32, 121, 32, 32, "0x70003F4F", false) -- "Stance: Endurance"
        self.stanceSkillBar:AddLabel("Stance: Precision", self.formSlots[1], 1)
        self.stanceSkillBar:AddLabel("Stance: Strength", self.formSlots[2], 2)
        self.stanceSkillBar:AddLabel("Stance: Endurance", self.formSlots[3], 3)
        self.stance = self.ClassAttr:GetStance()
    end
    
    -- Handle initial state
    for i = 1, self.effectList:GetCount(), 1 do
        local name = self.effectList:Get(i):GetName()

        --if self.formSlots[name] then self.formSlots[name]:ToggleVisible(true); self.currentForm = name end
    end 


    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()


        if self.skills[name] and not(self.noSkills) then
            if self.skills[name][3] == 1 then
                self.skillSlots[name] = ClassSkillSlot(self.normalSkillBar, self.width / 2 - 16, 0, 32, 32, self.skills[name][2], false)
                self.normalSkillBar:AddLabel(name, self.skillSlots[name], self.skills[name][1])
                self.skillCount = self.skillCount + 1
            elseif self.skills[name][3] == 2 then
                self.specialSkillSlots[name] = ClassSkillSlot(self.specialSkillBar, self.width / 2 - 16, 0, 32, 32, self.skills[name][2], false)
                self.specialSkillBar:AddLabel(name, self.specialSkillSlots[name], self.skills[name][1])
                self.specialSkillCount = self.specialSkillCount + 1
            end
        end
    end

    local padding = (self.width - self.skillCount * 32 ) / 2

    local positionCounter = 0
    for key, value in spairs(self.skillSlots, function(t,a,b) return self.skills[b][1] > self.skills[a][1] end) do
        value:SetPosition(padding + positionCounter * 32, 0)
        positionCounter = positionCounter + 1
    end

    local specialPadding = (self.width - self.specialSkillCount * 32 ) / 2

    positionCounter = 0
    for key, value in spairs(self.specialSkillSlots, function(t,a,b) return self.skills[b][1] > self.skills[a][1] end) do
        value:SetPosition(specialPadding + positionCounter * 32, 0)
        positionCounter = positionCounter + 1
    end

    for key, value in pairs(self.dynamicSkillTable) do
        self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[2], false, false, nil, 1, 1, true, false, true), value[3])
    end

    for key, value in pairs(self.dynamicEffectTable) do
        if not(self.specialEffectTable[key]) then
            self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, true), value[2])
        end
    end

    for key, value in pairs(self.specialEffectTable) do
        self.buffSkillBar:AddLabel(key, StackingClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, true, value[3]), value[2])
    end

    local barWidth = self.skillCount * 32
    if barWidth == 0 then barWidth = 320 end

    -- Focus bar
    --ResourceBar:Constructor(parent, width, height, boxes, text, y, borderColour)
    self.focusBar = ResourceBar(self)
    --self.focusBar:SetParent(self)
    self.focusBar:SetPosition(1 + (self.width - 320) / 2, 32)
    --self.focusBar:SetColours(nil, Turbine.UI.Color(0.6, 0.5, 0, 0), nil, nil)
    --self.focusBar:SetMaxValue(100)
    self.focusBar:ChangeResource(self.ClassAttr:GetFocus())

    -- Power bar
    self.powerBar = VitalBar(barWidth - 1, 4, true, Turbine.UI.ContentAlignment.MiddleCenter)
    self.powerBar:SetParent(self)
    self.powerBar:SetPosition(1 + (self.width - barWidth) / 2, 52)
    self.powerBar:SetColours(nil, Turbine.UI.Color(0.6, 0, 0, 1), nil, nil)
    self.powerBar:SetMaxValue(self.player:GetMaxPower())
    self.powerBar:SetCurrentValue(self.player:GetPower())
end

function HunterTools:SetCallbacks()
    self.effectCallbacks["EffectAdded"] = AddCallback(self.effectList, "EffectAdded", 
    function(sender, args)
        local effect = sender:Get(args.Index) 
        local effectName = effect:GetName()

        --ChatOutput(effectName .. effect:GetIcon())

        if self.dynamicEffectTable[effectName] then 
            if effectName == "Volley" then
                self.buffSkillBar:ToggleLabel(effectName, true)
            elseif self.dynamicEffectTable[effectName][1] == effect:GetIcon() then
                self.buffSkillBar:ToggleLabel(effectName, true, effect:GetDuration())
            end
        end
    end)
    
    self.effectCallbacks["EffectRemoved"] = AddCallback(self.effectList, "EffectRemoved", 
    function(sender, args)

        local effect = args.Effect
        if self.removeEffectTable[effect:GetName()] then
            self.buffSkillBar:ToggleLabel(effect:GetName(), false)
        end

        --[[
        if self.dynamicEffectTable[effect:GetName()] and 
        self.dynamicEffectTable[effect:GetName()][1] == effect:GetIcon() and 
        not(self.exceptionEffects[effectName]) then
            self.buffSkillBar:ToggleLabel(effect:GetName(), false)
        end
        --]]
    end)

    self.attrCallbacks["FocusChanged"] = AddCallback(self.ClassAttr, "FocusChanged", function(sender, args) self.focusBar:ChangeResource( sender:GetFocus() ) end)
    self.playerCallbacks["PowerChanged"] = AddCallback(self.player, "PowerChanged", function(sender, args) self.powerBar:SetCurrentValue( sender:GetPower() ) end)

    --[[
    self.attrCallbacks = AddCallback(self.ClassAttr, "StanceChanged", function(sender, args) 
        if self.stance > 0 then
            self.formSlots[self.stance]:ToggleVisible(false)
        end
        self.stance = sender:GetStance()
        if self.stance > 0 then
            self.formSlots[self.stance]:ToggleVisible(true)
        end
    end)
    --]]


    -- skill callbacks
    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()
        --ChatOutput(name .. item:GetSkillInfo():GetIconImageID())

        self.skillCallbacks[name] = {}

        if self.skills[name] and not(self.noSkills) then
            self.skillsLUT[name] = item
            if self.skills[name][3] == 1 then
                table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                    self.normalSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
                end))
            elseif self.skills[name][3] == 2 then
                table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                    self.specialSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
                end))
            end
        end

        if self.dynamicSkillTable[name] then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.buffSkillBar:ToggleLabel(name, true, self.dynamicSkillTable[name][1])
            end))
        end
        
        if self.stanceSkills[name] and not(self.noSkills) then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                if self.stanceSkills[name] ~= self.ClassAttr:GetStance() then
                    self.stanceSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown()) 
                end
            end))
        end
    end

    --[[
    self.playerCallbacks["InCombatChanged"] = AddCallback(self.player, "InCombatChanged",
    function(sender, args)
        if self.ferocious and not(self.player:IsInCombat()) then
            self.buffSkillBar:ToggleLabel("Ferocious Free Heal", true, 9)
        end
    end)
    --]]
end

function HunterTools:RemoveCallbacks()
    for key, value in pairs(self.effectCallbacks) do
        RemoveCallback(self.effectList, key, value)
    end

    RemoveCallback(self.ClassAttr, "FocusChanged", self.attrCallbacks["FocusChanged"])

    --player callbacks
    for key, value in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, key, value)
    end

    for key, value in pairs(self.skillCallbacks) do
        for _, callback in pairs(value) do
            RemoveCallback(self.skillsLUT[key], "ResetTimeChanged", callback)
        end
    end

    collectgarbage()
end

function HunterTools:RemoveSkillObjects()
    self.buffSkillBar:Unload()
    self.normalSkillBar:Unload()
    self.specialSkillBar:Unload()
    self.stanceSkillBar:Unload()
    self.focusBar:SetParent(nil)
    self.powerBar:SetParent(nil)

    ChatEventHandler:SubscribeTools(nil)
    ChatEventHandler:TogglePlayerCombat(false)

    for _, value in pairs(self.formSlots) do
        value:Unload()
    end

    self.formSlots = {}
    self.skillSlots = {}
    self.specialSkillSlots = {}

    self.skillCount = 0
    self.specialSkillCount = 0

    collectgarbage()
end

function HunterTools:ParseUpdate(message)
    local source,_,skillName,target,_ = string.match(string.gsub(string.gsub(message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"),"^(.*) scored a (.*)hit with (.*) on (.*) for (.-) (.*)%.$")
    if self.skillNameTimers[skillName] then
        self.buffSkillBar:ToggleLabel("Improved Penetrating Shot", true, self.dynamicSkillTable["Improved Penetrating Shot"][1])
    end
end

function HunterTools:ToggleMove()
    self.moveBox:ToggleMove()
end

function HunterTools:GetOptions(parent, x, y)
    local container = Turbine.UI.Control()
    container:SetParent(parent)
    container:SetPosition(x, y)
    container:SetSize(530 + 4, 100 + 4)
    container:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(container)
    SingleBackground:SetPosition(2, 2)
    SingleBackground:SetSize(530, 100)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox2 = Turbine.UI.Lotro.CheckBox();
    EffectBox2:SetParent(SingleBackground)
    EffectBox2:SetPosition(10, 50);
    EffectBox2:SetSize(200,20);
    EffectBox2:SetChecked(Settings.ClassToolsNoSkills)
    EffectBox2:SetText("Disable skill bars");
    EffectBox2:SetVisible(true);

    EffectBox2.CheckedChanged = function()
        Settings.ClassToolsNoSkills = EffectBox2:IsChecked()
    end

    
end

function HunterTools:GetData()
    return self.data
end

function HunterTools:LoadData()
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.effectList = self.player:GetEffects()
    self.ClassAttr = self.player:GetClassAttributes()
    self.trainedSkills = self.player:GetTrainedSkills()
end

function HunterTools:Load()
    self:SetSkillObjects()
    self:SetCallbacks()
end

function HunterTools:Unload()
    self:RemoveCallbacks()
    self:RemoveSkillObjects()
end

function HunterTools:Reload()
    self:Unload()
    self:LoadData()
    self:Load()
end

function HunterTools:ChangeData(key, value)
    self.data[key] = value
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

BleedTimerLabel = class(Turbine.UI.Window)
function BleedTimerLabel:Constructor(parent, x, y, base, normal, baseIcon, visible, reverse, duration, normalOpacity, usageOpacity, hide, shade, text)
    Turbine.UI.Window.Constructor(self)

    self.base = base
    self.normal = normal
    self.reverse = reverse
    self.normalOpacity = normalOpacity
    self.usageOpacity = usageOpacity
    self.hide = hide
    self.shade = shade
    self.text = text

    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize(self.normal, self.normal)
    self:SetVisible(visible)
    self:SetOpacity(normalOpacity)
    self:SetMouseVisible(false)

    self.currentNumber = -1
    self.currentPercentage = 0

    self.baseImageID = 0x41007E35;

    self.IconLabel = Turbine.UI.Label()
    self.IconLabel:SetParent(self)
    self.IconLabel:SetMouseVisible(false)
    self.IconLabel:SetSize(self.base, self.base)
    self.IconLabel:SetStretchMode(1)
    self.IconLabel:SetBackground(baseIcon)
    self.IconLabel:SetSize(self.normal, self.normal)
    --self.IconLabel:SetBlendMode(Turbine.UI.BlendMode.GrayScale)
    --self.IconLabel:SetVisible(false)

    self.backgroundLabel = Turbine.UI.Label()
    self.backgroundLabel:SetParent(self)
    self.backgroundLabel:SetMouseVisible(false)
    --self.backgroundLabel:SetBackColorBlendMode(Turbine.UI.BlendMode.GrayScale)
    self.backgroundLabel:SetBackColor(Turbine.UI.Color(0.6, 0.3, 0.3, 0.3))
    self.backgroundLabel:SetSize(self.normal, self.normal)
    self.backgroundLabel:SetStretchMode(1)
    --self.backgroundLabel:SetBlendMode(Turbine.UI.BlendMode.Overlay)


    if self.shade then
        self.elapsedOverlay = Turbine.UI.Control();
        self.elapsedOverlay:SetStretchMode( 1 );
        self.elapsedOverlay:SetMouseVisible( false );
        --self.elapsedOverlay:SetZOrder( 99 );
        self.elapsedOverlay:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
        self.elapsedOverlay:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
        self.elapsedOverlay:SetParent( self );
        self.elapsedOverlay:SetPosition(-1, -1)
        self.elapsedOverlay:SetSize(self.normal + 2, self.normal + 2)
    end
    
    if self.text then
        self.textLabel = Turbine.UI.Label()
        self.textLabel:SetParent(self)
        self.textLabel:SetSize(self.normal, self.normal)
        self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        --self.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        self.textLabel:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
        self.textLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
        self.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        self.textLabel:SetMouseVisible(false)
    end

    -- Add timer overlay

    self.startTime = Turbine.Engine.GetGameTime()
end

function BleedTimerLabel:SetTimer(timer, maxTimer)
    if maxTimer then
        self.overlaydDuration = maxTimer
        self.startTime = Turbine.Engine.GetGameTime() - (maxTimer - timer)
    else
        self.overlaydDuration = timer
        self.startTime = Turbine.Engine.GetGameTime()
    end
    self.duration = timer
    self:SetOpacity(self.usageOpacity)

    --Updater:Subscribe(self)
end

function BleedTimerLabel:ExecuteUpdate(delta)

    self.duration = self.duration - delta
    if self.duration < 0 then 
        --Updater:UnSubscribe(self)
        self:SetOpacity(self.normalOpacity)
        if self.hide then self:SetVisible(false) end 

        if self.text then
            self.textLabel:SetText("")
        end
        return true
    end

    if self.shade then

        local percentComplete = math.floor(60 * (Turbine.Engine.GetGameTime() - self.startTime) / self.overlaydDuration)
        if self.reverse then
            percentComplete = 60 - percentComplete
        end

        if self.currentPercentage ~= percentComplete then 

            self.currentPercentage = percentComplete

            local imageId = self.baseImageID + self.currentPercentage            

            self.elapsedOverlay:SetStretchMode( 3 );
            self.elapsedOverlay:SetSize( 32, 32 );
            self.elapsedOverlay:SetBackground( imageId );
            self.elapsedOverlay:SetStretchMode( 1 );
            self.elapsedOverlay:SetSize( self.normal + 2, self.normal + 2);
        end
    end

    local newNumber = math.round(self.duration)
    if newNumber == self.currentNumber then return end

    self.currentNumber = newNumber

    if self.text then
        self.textLabel:SetStretchMode(nil)
        self.textLabel:SetStretchMode(1)
        self.textLabel:SetText(self.currentNumber)
    end
end

function BleedTimerLabel:ToggleVisible(value)
    if not(value) then
        self.backgroundLabel:SetVisible(true)
        self.textLabel:SetVisible(false)
    else
        self.backgroundLabel:SetVisible(false)
        self.textLabel:SetVisible(true)
    end

    --self:SetVisible(value)
    --self.IconLabel:SetVisible(value)
end

function BleedTimerLabel:Unload()
    self.IconLabel:SetParent(nil)
    if self.textLabel then self.textLabel:SetParent(nil) end
    if self.elapsedOverlay then self.elapsedOverlay:SetParent(nil) end
    self:SetParent(nil)
    self = nil
end

-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------

WardenTools = class(Turbine.UI.Window)
function WardenTools:Constructor(data)
    Turbine.UI.Window.Constructor(self)
    self.width = 500
    self.height = 150
    self:SetPosition(Settings.ClassToolsX, Settings.ClassToolsY)
    self:SetSize(self.width, self.height)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.data = data

    self.moveBox = MoveBox(self, self.width, self.height, "Warden Tools")

    self.bleedBar = DynamicSkillBar(self, 0, 0, self.width, 32, 32, 4, true)
    self.buffSkillBar = DynamicSkillBar(self, 0, 32, self.width, 32, 32, 2, true)
    self.normalSkillBar = DynamicSkillBar(self, 0, 57, self.width, 64, 32, 4, false)
    self.specialSkillBar = DynamicSkillBar(self, 0, 89, self.width, 64, 32, 4, false)
    self.stanceSkillBar = DynamicSkillBar(self, self.width / 2 - 64, 121, 128, 64, 32, 4, false)

    self:LoadData()

    --self.noSkills = Settings.ClassToolsNoSkills
    self.noSkills = true

    self.timeSinceLastUpdate = 0
    self.updateDelay = 0.3

    self.playerCallbacks = {}
    self.effectCallbacks = {}
    self.attrCallbacks = {}

    self.skillCallbacks = {}
    self.skillsLUT = {}

    self.skillCount = 0 
    self.specialSkillCount = 0
    self.stance = 1

    self.formSlots = {}
    
    self.skillSlots = {}
    self.specialSkillSlots = {} 

    self.qsa = Settings.ClassToolsWardenQS

    self.skills = {
        ["Quick Thrust"] = {1, "0x7000E867", 1},
        ["Shield-bash"] = {2, " 0x7000ED0E", 1},
        ["Warden's Taunt"] = {3, "0x7000EECF", 1},
        ["Gambit Default"] = {4, " 0x70015F56", 1},
        ["Recovery"] = {5, "0x70016A0A", 1},
        ["Quick Recovery"] = {6, "0x70016A09", 1},
        ["Spear and Spear"] = {7, "0x7002850A", 1},
        ["Spear and Shield"] = {8, "0x70015099", 1},
        ["Spear and Fist"] = {9, "0x70015098", 1},
        ["Shield and Shield"] = {10, "0x7002850B", 1},
        ["Shield and Spear"] = {11, "0x7001509D", 1},
        ["Shield and Fist"] = {12, "0x7001509B", 1},
        ["Fist and Fist"] = {13, "0x7002850C", 1},
        ["Fist and Spear"] = {14, "0x7001509A", 1},
        ["Fist and Shield"] = {15, "0x7001509C", 1},
        ["Marked Target"] = {16, "0x70036550", 1},

        ["Hampering Javelin"] = {18, "0x70014833", 1},
        ["Ambush"] = {19, "0x7000EEC4", 1},
        ["Diminshed Target"] = {20, "0x70036551", 1},
        ["Wages of Fear"] = {21, "0x70014831", 1},

        ["First Aid"] = {5, "0x7003A654", 2},
        ["Shield-slam"] = {6, "0x7004E1FF", 2},
        ["Steadfast"] = {7, "0x7003A395", 2},
        ["Battle Preparation"] = {8, "0x7002BEEC", 2},
        ["Never Surrender"] = {9, "0x7003B619", 2},
        ["Battle Memory I"] = {10, "0x70028906", 2},
        ["Recklessness"] = {11, "0x700363A8", 2},


        --["Desperate Flight"] = {1, "0x70003F40", 1},

        --["Pinning Shot"] = {1, "0x70036497", 1},
        --["Strength of the Earth"] = {1, "0x7000A2D4", 1},
        --["Beneath Notice"] = {1, "0x70020DF8", 1},


    }

    self.skillNameTimers = {
    }

    if self.data == nil then
        self.data = {}
        for key, value in pairs(self.skills) do
            self.data[key] = {true, value[1], value[3]}
        end
    else
        for key, value in pairs(self.data) do
            --ChatOutput(value[1])
            if value[1] == false then
                self.skills[key] = nil
            else
                self.skills[key] = {value[2], self.skills[key][2], value[3]}
            end
        end
    end

    self.dynamicSkillTable = {
        --["Encouraging Roar"] = {15, 1091940904, 2},
        --109194090
    }

    self.dynamicEffectTable = {
        -- Yellow + Base
        --["Recuperate"] = {1091940911, 3},
        ["Preparing for Battle"] = {1091692906, 100},
        ["Reckless"] = {1091659503, 15},

        -- Yellow
        ["Seize the Moment"] = {1091916302, 1},
        ["Momentum"] = {1091830134, 2},
        ["Adroit Manoeuvre"] = {1091478097, 16},
        ["Adroit Manoeuvre - Induction Reduction"] = {1091478097, 17},
        ["Warden's Triumph- Ranged"] = {1091478187, 19},
        ["Warden's Triumph"] = {1091478187, 18},

        --Blue
        --
        ["Tier 1 Heal over Time"] = {1091469960, 40},
        ["Tier 2 Heal over Time"] = {1091471259, 41},
        ["Tier 3 Heal over Time"] = {1091471258, 42},
        ["Tier 4 Heal over Time"] = {1091471247, 43},

        ["Enduring Shieldwork"] = {1091469964, 50},
        ["Enduring Advanced Shieldwork"] = {1091471259, 51},
        ["Enduring Expert Shieldwork"] = {1091471258, 52},

        ["Defiance"] = {1091830177, 60},
        ["Conviction"] = {1091478183, 61},

        ["Enduring Armour Use"] = {1091469960, 70},
        ["Enduring Advanced Armour Use"] = {1091471254, 71},
        ["Enduring Expert Armour Use"] = {1091471266, 72},
        ["Enduring Tactical Armour Use"] = {1091478183, 73},

        ["Shield Mastery"] = {1091471248, 30},
        ["Tactically Sound"] = {1090541176, 20},
        ["Shield Tactics"] = {1091659503, 31},
        ["Darkest Before Dawn"] = {1091719861, 21},

        ["For the Free Peoples"] = {1091830171, 80},

        ["Fellowship Protector - Tier 1"] = {1091916300, 90, 1},
        ["Fellowship Protector - Tier 2"] = {1091916300, 90, 2},
        ["Fellowship Protector - Tier 3"] = {1091916300, 90, 3},
        ["Fellowship Protector - Tier 4"] = {1091916300, 90, 4},
        ["Fellowship Protector - Tier 5"] = {1091916300, 90, 5},
        ["Fellowship Protector - Tier 6"] = {1091916300, 90, 6},
        ["Fellowship Protector - Tier 7"] = {1091916300, 90, 7},
        ["Fellowship Protector - Tier 8"] = {1091916300, 90, 8},
        ["Fellowship Protector - Tier 9"] = {1091916300, 90, 9},
        ["Fellowship Protector - Tier 10"] = {1091916300, 90, 10},

    }

    self.specialEffectTable = {
        ["Fellowship Protector - Tier 1"] = {1091916300, 90, 1},
        ["Fellowship Protector - Tier 2"] = {1091916300, 90, 2},
        ["Fellowship Protector - Tier 3"] = {1091916300, 90, 3},
        ["Fellowship Protector - Tier 4"] = {1091916300, 90, 4},
        ["Fellowship Protector - Tier 5"] = {1091916300, 90, 5},
        ["Fellowship Protector - Tier 6"] = {1091916300, 90, 6},
        ["Fellowship Protector - Tier 7"] = {1091916300, 90, 7},
        ["Fellowship Protector - Tier 8"] = {1091916300, 90, 8},
        ["Fellowship Protector - Tier 9"] = {1091916300, 90, 9},
        ["Fellowship Protector - Tier 10"] = {1091916300, 90, 10},
    }

    self.removeEffectTable = {
        --["Aiding Strike - Tier 1"] = true,
        ["Preparing for Battle"] = true,
        ["Fellowship Protector - Tier 1"] = true,
        ["Fellowship Protector - Tier 2"] = true,
        ["Fellowship Protector - Tier 3"] = true,
        ["Fellowship Protector - Tier 4"] = true,
        ["Fellowship Protector - Tier 5"] = true,
        ["Fellowship Protector - Tier 6"] = true,
        ["Fellowship Protector - Tier 7"] = true,
        ["Fellowship Protector - Tier 8"] = true,
        ["Fellowship Protector - Tier 9"] = true,
        ["Fellowship Protector - Tier 10"] = true,
    }

    --["In the Fray - Stance"] = {1, "0x7003639B", 2},
    --["Assailment - Stance"] = {2, "0x7003639C", 2},

    self.stanceSkills = {
        ["Assailment - Stance"] = 1,
        ["In the Fray - Stance"] = 2,
    }

    -- Small QS 0x41140177
    -- Medium QS 0x4114017E
    -- War cry 0x410E8782
    -- Brink 0x410E8793
    -- Surety 0x410E8785
    -- Desolation 0x410EA2AA
    -- Precise blow 0x410E879E
    -- Piercing strike 0x410E878D
    -- Spear of Virtue 0x410E878C
    -- Power Attack 0x410E8798 LB
    -- Mighty Blow 0x410E879F MB
    -- Unerring Strike 0x41104562
    -- Resounding Challenge  0x4112B441

    -- Ranged Power Attack 0x41123894
    -- Ranged Mighty blow 0x41123899
    -- Ranged Unerring Strike 0x4111BF69

    -- Battle prep 0x4111E96A
    -- Never Surrender 0x4110BE84
    -- Never Surrender Effect Icon 0x4111BF69

    -- Melee damage buff 0x4111BF69


    self.bleedSkills = {
        ["Power Attack"] = {1, 0x410E8798},
        ["Mighty Blow"] = {2, 0x410E879F},
        ["Unerring Strike"] = {3, 0x41104562},
        ["Low Bleed - Quick Sweep"] = {4, 0x41140177},
        ["Medium Bleed - Quick Sweep"] = {5, 0x4114017E},
        ["Precise Blow"] = {6, 0x410E879E},
        ["Piercing Strike"] = {7, 0x410E878D},
        ["Spear of Virtue"] = {8, 0x410E878C},
        ["War-cry"] = {9, 0x410E8782},
        ["Brink of Victory"] = {10, 0x410E8793},
        ["Surety of Death"] = {11, 0x410E8785},
        ["Desolation"] = {12, 0x410EA2AA},
        ["Ranged Resounding Challenge"] = {13, 0x4112B441},
        ["Ranged Unerring Strike"] = {14, 0x4112389E}
    }

    self.bleedDuration = {
        ["Power Attack"] = 24,
        ["Mighty Blow"] = 24,
        ["Unerring Strike"] = 24,
        ["Low Bleed - Quick Sweep"] = 20,
        ["Medium Bleed - Quick Sweep"] = 20,
        ["Precise Blow"] = 24,
        ["Piercing Strike"] = 24,
        ["Spear of Virtue"] = 24,
        ["War-cry"] = 24,
        ["Brink of Victory"] = 24,
        ["Surety of Death"] = 24,
        ["Desolation"] = 24,
        ["Ranged Resounding Challenge"] = 24,
        ["Ranged Unerring Strike"] = 28,
    }

    if Settings.ClassToolsWardenExtraTick then
        for key, value in pairs(self.bleedDuration) do
            self.bleedDuration[key] = value + 4
        end
    end

    local bleedtablecounter = 0
    for key, value in pairs(Settings.ClassToolsWardenBleeds) do
        if self.bleedSkills[key] and value == false then
            self.bleedSkills[key] = nil
        end
    end

    if bleedtablecounter == 0 then
        for key, value in pairs(self.bleedSkills) do
            Settings.ClassToolsWardenBleeds[key] = true
        end
    end

    self.specialBleedSkills = {
        ["Low Bleed - Quick Sweep"] = 0,
        ["Medium Bleed - Quick Sweep"] = 0,
        ["Low Bleed"] = 0,
        ["Medium Bleed"] = 0,
    }

    self.initialToBleed = {
        ["Low Bleed - Quick Sweep"] = "Low Bleed - Quick Sweep",
        ["Medium Bleed - Quick Sweep"] = "Low Bleed - Quick Sweep",
        ["Power Attack"] = "Low Bleed",
        ["Mighty Blow"] = "Medium Bleed",
    }

    self.bleedToInitial = {
        ["Low Bleed - Quick Sweep"] = "Low Bleed - Quick Sweep",
        ["Medium Bleed - Quick Sweep"] = "Low Bleed - Quick Sweep",
        ["Low Bleed"] = "Power Attack",
        ["Medium Bleed"] = "Mighty Blow",
    }

    self.maxBleedInterval = {
        ["Low Bleed - Quick Sweep"] = 4.2,
        ["Medium Bleed - Quick Sweep"] = 4.2,
        ["Low Bleed"] = 8.2,
        ["Medium Bleed"] = 8.2,
    }

    self.qsaTable = {
        ["Low Bleed - Quick Sweep"] = true,
        ["Medium Bleed - Quick Sweep"] = true,
        ["Marked Target"] = true,
        ["Diminished Target"] = true,
    }

    if self.qsa then
        for key, value in pairs(self.specialBleedSkills) do
            if string.find(key, "Quick Sweep") then self.specialBleedSkills[key] = nil end
        end

        for key, value in pairs(self.initialToBleed) do
            if string.find(key, "Quick Sweep") then self.initialToBleed[key] = nil end
        end

        for key, value in pairs(self.bleedToInitial) do
            if string.find(key, "Quick Sweep") then self.bleedToInitial[key] = nil end
        end

        for key, value in pairs(self.maxBleedInterval) do
            if string.find(key, "Quick Sweep") then self.maxBleedInterval[key] = nil end
        end

        self.bleedSkills["Marked Target"] = {15, 1091804897}
        self.bleedSkills["Diminished Target"] = {16, 1091806157}
        
    end

    self.specialBleedsActive = {}

    self.bleedSlots = {}

    self:Load()

    self:TargetEvents(self.player)
end

function WardenTools:SetSkillObjects()

    ChatEventHandler:SubscribeTools(self)
    ChatEventHandler:TogglePlayerCombat(true)

    if not(self.noSkills) then
        self.formSlots[1] = ClassSkillSlot(self, self.width / 2 + 16, 121, 32, 32, "0x7003639C", false) -- "Stance: Assailment"
        self.formSlots[2] = ClassSkillSlot(self, self.width / 2 - 16, 121, 32, 32, "0x7003639B", false) -- "Stance: In the Fray"
        self.stanceSkillBar:AddLabel("Assailment - Stance", self.formSlots[1], 1)
        self.stanceSkillBar:AddLabel("In the Fray - Stance", self.formSlots[2], 2)
        self.stance = self.ClassAttr:GetStance()


        self.stanceSkillBar:AddLabel("Force March", ClassSkillSlot(self, self.width / 2 - 48, 121, 32, 32, "0x700105CC", false), 1)
        self.stanceSkillBar:AddLabel("Careful Step", ClassSkillSlot(self, self.width / 2 + 48, 121, 32, 32, "0x70014860", false), 4)
    end

    local bleedSkills = 0
    for key, value in pairs(self.bleedSkills) do
        --(parent, x, y, base, normal, baseIcon, visible, reverse, duration, normalOpacity, usageOpacity, hide, shade, text)
        self.bleedSlots[key] = BleedTimerLabel(self.bleedBar, 0, 0, 32, 32, value[2], true, false, nil, 1, 1, false, false, true)
        self.bleedBar:AddLabel(key, self.bleedSlots[key])
        bleedSkills = bleedSkills + 1
    end

    local bleedPosition = 0
    local bleedPadding = self.width / 2 - bleedSkills * 16
    for key, value in spairs(self.bleedSlots, function(t,a,b) return self.bleedSkills[b][1] > self.bleedSkills[a][1] end) do
        value:SetPosition(bleedPadding + bleedPosition * 32, 0)
        bleedPosition = bleedPosition + 1
    end

    if self.qsa then
        for key, value in pairs(self.bleedSkills) do
            if string.find(key, "Quick Sweep") then self.bleedSkills[key] = nil end
        end
        self.bleedSkills["Marked Target"] = nil
        self.bleedSkills["Diminished Target"] = nil
    end
    

    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()


        if self.skills[name] and not(self.noSkills) then
            if self.skills[name][3] == 1 then
                self.skillSlots[name] = ClassSkillSlot(self.normalSkillBar, self.width / 2 - 16, 0, 32, 32, self.skills[name][2], false)
                self.normalSkillBar:AddLabel(name, self.skillSlots[name], self.skills[name][1])
                self.skillCount = self.skillCount + 1
            elseif self.skills[name][3] == 2 then
                self.specialSkillSlots[name] = ClassSkillSlot(self.specialSkillBar, self.width / 2 - 16, 0, 32, 32, self.skills[name][2], false)
                self.specialSkillBar:AddLabel(name, self.specialSkillSlots[name], self.skills[name][1])
                self.specialSkillCount = self.specialSkillCount + 1
            end
        end
    end

    local padding = (self.width - self.skillCount * 32 ) / 2

    local positionCounter = 0
    for key, value in spairs(self.skillSlots, function(t,a,b) return self.skills[b][1] > self.skills[a][1] end) do
        value:SetPosition(padding + positionCounter * 32, 0)
        positionCounter = positionCounter + 1
    end

    local specialPadding = (self.width - self.specialSkillCount * 32 ) / 2

    positionCounter = 0
    for key, value in spairs(self.specialSkillSlots, function(t,a,b) return self.skills[b][1] > self.skills[a][1] end) do
        value:SetPosition(specialPadding + positionCounter * 32, 0)
        positionCounter = positionCounter + 1
    end

    for key, value in pairs(self.dynamicSkillTable) do
        self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[2], false, false, nil, 1, 1, true, false, true), value[3])
    end

    for key, value in pairs(self.dynamicEffectTable) do
        if not(self.specialEffectTable[key]) then
            self.buffSkillBar:AddLabel(key, ClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, true), value[2])
        end
    end

    for key, value in pairs(self.specialEffectTable) do
        self.buffSkillBar:AddLabel(key, StackingClassTimerLabel(self.buffSkillBar, 0, 0, 32, 32, value[1], false, false, nil, 1, 1, true, false, true, value[3]), value[2])
    end

    local barWidth = self.skillCount * 32
    if barWidth == 0 then barWidth = 320 end

end

function WardenTools:QSCheck(effect)
    if self.qsaTable[effect:GetName()] then
        local effectTime = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())
        if effectTime and effectTime > 0 then
            self.bleedBar:ToggleLabel(effect:GetName(), true, effectTime)
        end
    end
end

function WardenTools:TargetEvents(player)

    if self.targetEffectCallback then
        RemoveCallback(self.targetEffects, "EffectAdded", self.targetEffectCallback)
        self.targetEffectCallback = nil
        self.targetEffects = nil
    end
    -- Release memory and force clean it
    self.taget = nil
    collectgarbage()


    -- Start regathering info
    self.target = player:GetTarget()

    if self.target then 

        if self.player:GetName() == player:GetTarget():GetName() then
            return
        end

        -- Check if target can have effects
        if self.target.GetEffects then
            self.targetEffects = self.target:GetEffects()
            self.targetEffectCallback = AddCallback(self.targetEffects, "EffectAdded", function(sender, args) self:QSCheck(sender:Get(args.Index)) end)
        end
    end
end 

function WardenTools:SetCallbacks()
    self.effectCallbacks["EffectAdded"] = AddCallback(self.effectList, "EffectAdded", 
    function(sender, args)
        local effect = sender:Get(args.Index) 
        local effectName = effect:GetName()

        --ChatOutput(effectName .. effect:GetIcon())

        if self.dynamicEffectTable[effectName] then 
            if effectName == "Volley" then
                self.buffSkillBar:ToggleLabel(effectName, true)
            elseif self.dynamicEffectTable[effectName][1] == effect:GetIcon() then
                self.buffSkillBar:ToggleLabel(effectName, true, effect:GetDuration())
            end
        end
    end)

    if self.qsa then
        self.playerCallbacks["TargetChanged"] = AddCallback(self.player, "TargetChanged", function(sender, args) self:TargetEvents(sender) end)
    end


    self.effectCallbacks["EffectRemoved"] = AddCallback(self.effectList, "EffectRemoved", 
    function(sender, args)


        local effect = args.Effect
        if effect and self.removeEffectTable[effect:GetName()] then
            self.buffSkillBar:ToggleLabel(effect:GetName(), false)
        end

        --[[
        if self.dynamicEffectTable[effect:GetName()] and 
        self.dynamicEffectTable[effect:GetName()][1] == effect:GetIcon() and 
        not(self.exceptionEffects[effectName]) then
            self.buffSkillBar:ToggleLabel(effect:GetName(), false)
        end
        --]]
    end)

    -- skill callbacks
    local index = 1
    for i = 1, self.trainedSkills:GetCount(), 1 do
        local item = self.trainedSkills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName()
        --ChatOutput(name .. item:GetSkillInfo():GetIconImageID())

        self.skillCallbacks[name] = {}

        if self.skills[name] and not(self.noSkills) then
            self.skillsLUT[name] = item
            if self.skills[name][3] == 1 then
                table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                    self.normalSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
                end))
            elseif self.skills[name][3] == 2 then
                table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                    self.specialSkillBar:SetLabelTimer(name, item:GetResetTime() - Turbine.Engine.GetGameTime(), item:GetCooldown())
                end))
            end
        end

        if self.dynamicSkillTable[name] then
            self.skillsLUT[name] = item
            table.insert(self.skillCallbacks[name], AddCallback(item, "ResetTimeChanged", function(sender, args) 
                self.buffSkillBar:ToggleLabel(name, true, self.dynamicSkillTable[name][1])
            end))
        end
    end

    --[[
    self.playerCallbacks["InCombatChanged"] = AddCallback(self.player, "InCombatChanged",
    function(sender, args)
        if self.ferocious and not(self.player:IsInCombat()) then
            self.buffSkillBar:ToggleLabel("Ferocious Free Heal", true, 9)
        end
    end)
    --]]
end

function WardenTools:RemoveCallbacks()
    for key, value in pairs(self.effectCallbacks) do
        RemoveCallback(self.effectList, key, value)
    end

    --player callbacks
    for key, value in pairs(self.playerCallbacks) do
        RemoveCallback(self.player, key, value)
    end

    for key, value in pairs(self.skillCallbacks) do
        for _, callback in pairs(value) do
            RemoveCallback(self.skillsLUT[key], "ResetTimeChanged", callback)
        end
    end

    collectgarbage()
end

function WardenTools:RemoveSkillObjects()
    self.buffSkillBar:Unload()
    self.normalSkillBar:Unload()
    self.specialSkillBar:Unload()
    self.stanceSkillBar:Unload()
    self.bleedBar:Unload()

    ChatEventHandler:SubscribeTools(nil)
    ChatEventHandler:TogglePlayerCombat(false)

    if self.qsa then
        self.bleedSkills["Low Bleed - Quick Sweep"] = {4, 0x41140177}
        self.bleedSkills["Medium Bleed - Quick Sweep"] = {5, 0x4114017E}
        self.bleedSkills["Marked Target"] = {15, 1091804897}
        self.bleedSkills["Diminished Target"] = {16, 1091806157}
    end

    for _, value in pairs(self.formSlots) do
        value:Unload()
    end

    self.formSlots = {}
    self.skillSlots = {}
    self.specialSkillSlots = {}

    self.skillCount = 0
    self.specialSkillCount = 0

    collectgarbage()
end

function WardenTools:ParseUpdate(message)
    local source,_,skillName = string.match(string.gsub(string.gsub(message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"),"^(.*) scored a (.*)hit with (.*) on")
    if self.bleedSkills[skillName] then
        if not(self.specialBleedsActive[skillName]) then 
            self.bleedBar:ToggleLabel(skillName, true, self.bleedDuration[skillName])
        end
        if self.initialToBleed[skillName] then 
            self.specialBleedsActive[self.initialToBleed[skillName]] = true
            self.specialBleedSkills[self.initialToBleed[skillName]] = Turbine.Engine.GetGameTime()
        end
    end

    if self.specialBleedSkills[skillName] then
        if string.find(skillName, "Low Bleed") or string.find(skillName, "Medium Bleed") then
            local interval = Turbine.Engine.GetGameTime() - self.specialBleedSkills[skillName]
            if interval > 4.3 then
                self.bleedBar:ToggleLabel(self.bleedToInitial[skillName], true, self.bleedDuration[self.bleedToInitial[skillName]] - 4)
            end
        end

        self.specialBleedSkills[skillName] = Turbine.Engine.GetGameTime()
    end
end

function WardenTools:ExecuteUpdate(delta)

    self.timeSinceLastUpdate = self.timeSinceLastUpdate + delta
    if self.timeSinceLastUpdate < self.updateDelay then return end

    self.timeSinceLastUpdate = 0
    

    for key, value in pairs(self.specialBleedsActive) do 
        if self.specialBleedSkills[key] + self.maxBleedInterval[key] < Turbine.Engine.GetGameTime() then
            self.specialBleedsActive[key] = nil
            self.bleedBar:ToggleLabel(self.bleedToInitial[key], nil)
        end
    end
end

function WardenTools:ToggleMove()
    self.moveBox:ToggleMove()
end

function WardenTools:GetOptions(parent, x, y)
    local container = Turbine.UI.Control()
    container:SetParent(parent)
    container:SetPosition(x, y)
    container:SetSize(530 + 4, 100 + 4)
    container:SetBackColor(Turbine.UI.Color(0, 0, 0))

    local SingleBackground = Turbine.UI.Control()
    SingleBackground:SetParent(container)
    SingleBackground:SetPosition(2, 2)
    SingleBackground:SetSize(530, 100)
    SingleBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local EffectBox2 = Turbine.UI.Lotro.CheckBox();
    EffectBox2:SetParent(SingleBackground)
    EffectBox2:SetPosition(300, 80);
    EffectBox2:SetSize(400,20);
    EffectBox2:SetChecked(Settings.ClassToolsWardenQS)
    EffectBox2:SetText("Accurate QS and javelin debuff tracking");
    EffectBox2:SetVisible(true);

    EffectBox2.CheckedChanged = function()
        Settings.ClassToolsWardenQS = EffectBox2:IsChecked()
    end

    local EffectBox4 = Turbine.UI.Lotro.CheckBox();
    EffectBox4:SetParent(SingleBackground)
    EffectBox4:SetPosition(450, 60);
    EffectBox4:SetSize(200,20);
    EffectBox4:SetChecked(Settings.ClassToolsWardenExtraTick)
    EffectBox4:SetText("+1 bleed pulse");
    EffectBox4:SetVisible(true);

    EffectBox4.CheckedChanged = function()
        Settings.ClassToolsWardenExtraTick = EffectBox4:IsChecked()
    end

    

    self.bleedBox = function(key, x, y)
        local EffectBox3 = Turbine.UI.Lotro.CheckBox();
        EffectBox3:SetParent(SingleBackground)
        EffectBox3:SetPosition(x, y);
        EffectBox3:SetSize(150,20);
        EffectBox3:SetMultiline(false)
        EffectBox3:SetChecked(Settings.ClassToolsWardenBleeds[key])
        EffectBox3:SetText(key);
        EffectBox3:SetVisible(true);
    
        EffectBox3.CheckedChanged = function()
            Settings.ClassToolsWardenBleeds[key] = EffectBox3:IsChecked()
        end
    end

    local xCounter = 0
    local yCounter = 0
    for key, value in pairs(Settings.ClassToolsWardenBleeds) do
        self.bleedBox(key, math.floor(xCounter / 5) * 150 , (yCounter % 5) * 20)
        xCounter = xCounter + 1
        yCounter = yCounter + 1
    end
end

function WardenTools:GetData()
    return self.data
end

function WardenTools:LoadData()
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.effectList = self.player:GetEffects()
    self.ClassAttr = self.player:GetClassAttributes()
    self.trainedSkills = self.player:GetTrainedSkills()
end

function WardenTools:Load()
    self:SetSkillObjects()
    self:SetCallbacks()
    Updater:Subscribe(self)
end

function WardenTools:Unload()
    self:RemoveCallbacks()
    self:RemoveSkillObjects()
    Updater:UnSubscribe(self)
end

function WardenTools:Reload()
    self:Unload()
    self:LoadData()
    self:Load()
end

function WardenTools:ChangeData(key, value)
    self.data[key] = value
end